# RPM Spec File for Wacs HostAuth 0.8.6
# NB: this version does not work with selinux enabled (yet)
%define name wacs-hostauth
%define metaname wacs
%define version 0.8.6
%define release 1

%{!?wacs_user:%define wacs_user wacs}
%{!?wacs_group:%define wacs_group wacs}
%{!?http_user:%define http_user apache}

# work out the distro name, karch and type
%define distid %(lsb_release -si | sed 's/\ /_/g')
%define distrel %(lsb_release -sr)
%define procarch %(uname -m)

# work out the extension (Fedora & CentOS only at present)
%define DISTTAG %([ %distid == CentOS ] && echo "centos" || echo "fc" )
%define VER %{distrel}

Summary: WACS Adult Web Site Toolkit - Host-Based Authentication Provider
Name: %{name}
Version: %{version}
Release: %{release}.%{DISTTAG}%{VER}
Source: %{metaname}-%{version}.tar.gz
License: GPLv3
URL: http://wacsip.sourceforge.net
Group: Applications/Publishing
BuildRequires: pam-devel
BuildRoot: %{_tmppath}/%{metaname}-%{version}-%{release}-root
Vendor: The WACS Development Team

%description 
WACS is a tool for building Adult Web Sites; equally suitable for managing
a private collection or building a commercial site. It has many best of
breed features including dynamic filtering, model catalogs, automatic
download and powerful search engine.

This package contains the glue program needed to allow WACS to authenticate
users based upon their operating system account credentials on the server.

%prep
%setup -n %{metaname}-%{version}

%install
rm -rf %{buildroot}

(cd security; make -f Makefile all )

# binary files
install -d $RPM_BUILD_ROOT%{_bindir}
install -m 4751 security/pam_auth.%{procarch}-%{distid}%{distrel} $RPM_BUILD_ROOT%{_bindir}/pam_auth
install -d $RPM_BUILD_ROOT%{_datadir}/%{metaname}
install -m 0640 install/README.hostauth $RPM_BUILD_ROOT%{_datadir}/%{metaname}/
install -d $RPM_BUILD_ROOT%{_sysconfdir}/pam.d
install -m 0644 security/wacs.pam-F7 $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/wacs

%pre
getent group %wacs_group >/dev/null || groupadd -r %wacs_group
getent passwd %wacs_user >/dev/null || \
        useradd -m -g %wacs_group -r -c "WACS Files Owner" -s /bin/bash \
        %wacs_user >/dev/null 2>&1 || :
usermod -a -G %wacs_group %http_user >/dev/null 2>&1 || :

%post
# make sure we have setuid root on pam_auth - it just doesn't work
# without it.
chmod u+s %{_bindir}/pam_auth

%files
%defattr(1751,root,wacs)
%{_bindir}/pam_auth

%defattr(0755,root,wacs)
%{_sysconfdir}/pam.d/wacs

%defattr(0770,wacs,wacs)
%dir %{_datadir}/%{metaname}

%defattr(0660,wacs,wacs)
%{_datadir}/%{metaname}/README.hostauth

%changelog
* Mon Dec  1 2008 Beaky <wacs@beaky.name>
- fix to make it setuid rather than sticky bit (oops!)
- belt and braces to make absolutely sure it's setuid

* Sat Aug 23 2008 Beaky <wacs@beaky.name>
- fix to make sure required wacs username/group exists to make sure perms OK

* Wed Aug 20 2008 Beaky <wacs@beaky.name>
- corrected datadir name to wacs (metaname) from actual package name
- fixed permissions on the files that don't need to be setuid

* Wed Aug  6 2008 Beaky <wacs@beaky.name>
- added README.hostauth file

* Tue Aug  5 2008 Beaky <wacs@beaky.name>
- added wacs pam.d configuration file

* Fri Jul 25 2008 Beaky <wacs@beaky.name>
- broke off separate spec file for wacs-hostauth
