# RPM Spec File for Wacs 0.8.6
# NB: this version does not work with selinux enabled (yet)
%define name wacs
%define version 0.8.6
%define release 1

# work out the distro name and type
%define distid %(lsb_release -si | sed 's/\ /_/g')
%define distrel %(lsb_release -sr)

%define perl_ver %([ %distid == Fedora -a %distrel -gt 8 ] && echo 5.10.0 || echo 5.8.8 )
%define perlmodule %([ %distid == Fedora -a %distrel -gt 12 ] && echo "%{_datadir}/perl5" || echo "%{_exec_prefix}/lib/perl5/%{perl_ver}" )

%{!?wacs_user:%define wacs_user wacs}
%{!?wacs_group:%define wacs_group wacs}
%{!?http_user:%define http_user apache}

# work out the extension (Fedora & CentOS only at present)
%define DISTTAG %([ %distid == CentOS ] && echo "centos" || echo "fc" )
%define VER %{distrel}

Summary: WACS Adult Web Site Toolkit
Name: %{name}
Version: %{version}
Release: %{release}.%{DISTTAG}%{VER}
Source: %{name}-%{version}.tar.gz
License: GPLv3
URL: http://wacsip.sourceforge.net
Group: Applications/Publishing
Requires: httpd >= 2, mysql-server >= 5, perl >= 5
Requires: perl(DBI)
Requires: perl-DBD-MySQL
Requires: netpbm
Requires: netpbm-progs
Requires: wacs-core >= %{version}
Requires: wacs-tools >= %{version}
Requires: wacs-samples >= %{version}
Requires: wacs-hostauth >= %{version}
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Vendor: The WACS Development Team
Buildarch: noarch

%description 
WACS is a tool for building Adult Web Sites; equally suitable for managing
a private collection or building a commercial site. It has many best of
breed features including dynamic filtering, model catalogs, automatic
download and powerful search engine.

%prep
%setup

%install
rm -rf %{buildroot}

# top of the tree - we do need to own this or it won't be cleaned out
# if we remove the package
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/

# Web document tree objects - icons, stylesheets, etc.
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/html
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/html/glyphs
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/html/glyphs/controls
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/html/glyphs/flags
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/html/glyphs/frames
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/html/styles
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/html/addicons
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/html/icons
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/html/bigicons
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/html/bodyimage
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/html/altimage
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/html/images
install -m 0660 htmlbones/glyphs/*.png $RPM_BUILD_ROOT%{_datadir}/%{name}/html/glyphs
install -m 0660 htmlbones/glyphs/controls/*.png $RPM_BUILD_ROOT%{_datadir}/%{name}/html/glyphs/controls/
install -m 0660 htmlbones/glyphs/flags/*.jpg $RPM_BUILD_ROOT%{_datadir}/%{name}/html/glyphs/flags/
install -m 0660 htmlbones/glyphs/frames/*.png $RPM_BUILD_ROOT%{_datadir}/%{name}/html/glyphs/frames/
install -m 0660 htmlbones/styles/*.css $RPM_BUILD_ROOT%{_datadir}/%{name}/html/styles/
install -m 0660 htmlbones/styles/*.gif $RPM_BUILD_ROOT%{_datadir}/%{name}/html/styles/
install -m 0660 htmlbones/index.html-%{distid} $RPM_BUILD_ROOT%{_datadir}/%{name}/html/index.html
install -m 0660 htmlbones/csshorizontalmenu.js $RPM_BUILD_ROOT%{_datadir}/%{name}/html/csshorizontalmenu.js
install -m 0660 htmlbones/images/*.png $RPM_BUILD_ROOT%{_datadir}/%{name}/html/images/
install -m 0660 htmlbones/images/*.jpg $RPM_BUILD_ROOT%{_datadir}/%{name}/html/images/
# cache files
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/cache
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/cache/iconcache
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/cache/officons
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/cache/seticons
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/cache/vidicons
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/cache/dvdicons
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/cache/thumbs
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/cache/minithumbs
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/cache/scaled
# download files
install -m 0770 -d $RPM_BUILD_ROOT%{_localstatedir}/spool/%{name}/download
install -m 0770 -d $RPM_BUILD_ROOT%{_localstatedir}/spool/%{name}/archive
# lease files
install -m 0770 -d $RPM_BUILD_ROOT%{_localstatedir}/run/%{name}

# configuration files
install -m 0770 -d $RPM_BUILD_ROOT%{_sysconfdir}/%{name}.d/
install -m 0660 conf/%{distid}/wacs.cfg $RPM_BUILD_ROOT%{_sysconfdir}/%{name}.d/
install -m 0660 conf/%{distid}/wacs.acl $RPM_BUILD_ROOT%{_sysconfdir}/%{name}.d/
install -m 0660 conf/%{distid}/menu.cfg $RPM_BUILD_ROOT%{_sysconfdir}/%{name}.d/
install -d $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d
install -m 0660 conf/%{distid}/%{name}.conf $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d

# perl modules
# note these have been relocated completely as at 0.8.6
install -m 0771 -d $RPM_BUILD_ROOT%{perlmodule}/Wacs
install -m 0750 modules/wacs.pm $RPM_BUILD_ROOT%{perlmodule}/Wacs.pm
install -m 0750 modules/wacsid.pm $RPM_BUILD_ROOT%{perlmodule}/Wacs/WacsId.pm
install -m 0750 modules/wacsui.pm $RPM_BUILD_ROOT%{perlmodule}/Wacs/WacsUI.pm
install -m 0750 modules/wacsstd.pm $RPM_BUILD_ROOT%{perlmodule}/Wacs/WacsStd.pm
install -m 0750 install/WacsInstUtil.pm $RPM_BUILD_ROOT%{perlmodule}/Wacs/WacsInstUtil.pm

# script files
# retrieval
install -m 0771 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin
# wildcarded whole directories
install -m 0750 index/wacs* $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin
install -m 0750 models/wacs* $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin
install -m 0750 presentation/wacs* $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin
install -m 0750 retrieval/wacs* $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin
install -m 0750 search/wacs* $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin
install -m 0750 tag/wacs* $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin
# individual special cases
install -m 0750 install/wacssetup $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin
install -m 0750 download/wacsdnlnext $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin
install -m 0750 download/wacsdnlframe $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin
install -m 0750 download/wacsdnlcomp $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin

# explicit list: login, logout, pref
install -m 0750 security/wacslogin $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin
install -m 0750 security/wacslogout $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin
install -m 0750 security/wacspref $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin
# management tools
install -m 0750 manage/wacs* $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin
install -d $RPM_BUILD_ROOT%{_bindir}
install -m 0750 tools/* $RPM_BUILD_ROOT%{_bindir}
install -m 0750 migrate/wacs* $RPM_BUILD_ROOT%{_bindir}
install -m 0750 utils/* $RPM_BUILD_ROOT%{_bindir}
# explicit list: getarc, refresh, chkmodel
install -m 0750 download/getarc $RPM_BUILD_ROOT%{_bindir}
install -m 0750 download/refresh $RPM_BUILD_ROOT%{_bindir}
install -m 0750 download/chkmodel $RPM_BUILD_ROOT%{_bindir}
# utilities
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/utils
install -m 0750 populate/wacspop $RPM_BUILD_ROOT%{_datadir}/%{name}/utils/
install -m 0750 install/upgrade $RPM_BUILD_ROOT%{_datadir}/%{name}/utils/

# shares stuff - creation SQL scripts
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/creation
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/creation/MySQL5
install -m 0770 creation/mysql_*.sql $RPM_BUILD_ROOT%{_datadir}/%{name}/creation/MySQL5
install -m 0770 creation/create_mysql.sql $RPM_BUILD_ROOT%{_datadir}/%{name}/creation/MySQL5
install -d $RPM_BUILD_ROOT%{_datadir}/%{name}/creation/Oracle10
install -m 0770 creation/ora_*.sql $RPM_BUILD_ROOT%{_datadir}/%{name}/creation/Oracle10
install -m 0770 creation/create_oracle.sql $RPM_BUILD_ROOT%{_datadir}/%{name}/creation/Oracle10
# shares stuff - sample stuff
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/samples
install -m 0640 install/README.samples $RPM_BUILD_ROOT%{_datadir}/%{name}/samples/README.samples
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/samples/database
install -m 0770 populate/*.xml $RPM_BUILD_ROOT%{_datadir}/%{name}/samples/database
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/samples/models
install -m 0770 samples/*.xml $RPM_BUILD_ROOT%{_datadir}/%{name}/samples/models
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/samples/perl
install -m 0770 samples/perl/* $RPM_BUILD_ROOT%{_datadir}/%{name}/samples/perl
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/samples/junkyard
install -m 0660 junkyard/README $RPM_BUILD_ROOT%{_datadir}/%{name}/samples/junkyard
install -m 0660 junkyard/WHATSHERE $RPM_BUILD_ROOT%{_datadir}/%{name}/samples/junkyard
install -m 0770 junkyard/spinner $RPM_BUILD_ROOT%{_datadir}/%{name}/samples/junkyard
install -m 0770 junkyard/remcopy $RPM_BUILD_ROOT%{_datadir}/%{name}/samples/junkyard
install -m 0770 junkyard/conngraph $RPM_BUILD_ROOT%{_datadir}/%{name}/samples/junkyard
install -m 0770 junkyard/compare $RPM_BUILD_ROOT%{_datadir}/%{name}/samples/junkyard
install -m 0770 junkyard/fixdnl $RPM_BUILD_ROOT%{_datadir}/%{name}/samples/junkyard
# core stuff for docs
install -m 0771 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc
install -m 0771 -d $RPM_BUILD_ROOT%{_mandir}/man1
install -m 0660 docs/docs-index.html $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/index.html
install -m 0660 docs/man/*.1 $RPM_BUILD_ROOT%{_mandir}/man1

# documentation
# part one - PDF
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/pdf
install -m 0640 docs/userguide/pdf/userguide.pdf $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/pdf
install -m 0640 docs/programming/pdf/programming.pdf $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/pdf
install -m 0640 docs/configuration/pdf/configuration.pdf $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/pdf
install -m 0640 docs/installation/pdf/installation.pdf $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/pdf
install -m 0640 docs/administration/pdf/administration.pdf $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/pdf
install -m 0640 docs/manpages/pdf/manpages.pdf $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/pdf
# part two - HTML single page
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/userguide
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/userguide/images
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/userguide/icons
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/installation
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/installation/images
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/configuration
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/configuration/images
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/programming
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/programming/images
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/programming/icons
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/administration
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/administration/images
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/manpages
install -m 0770 -d $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/manpages/images
install -m 0640 docs/userguide/htmls/userguide.html $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/userguide
install -m 0640 docs/installation/htmls/installation.html $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/installation
install -m 0640 docs/configuration/htmls/configuration.html $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/configuration
install -m 0640 docs/programming/htmls/programming.html $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/programming
install -m 0640 docs/administration/htmls/administration.html $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/administration
install -m 0640 docs/manpages/htmls/manpages.html $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/manpages
# part three - HTML multipage (assumes no name clash with single page)
install -m 0640 docs/userguide/htmlm/*.html $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/userguide
install -m 0640 docs/installation/htmlm/*.html $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/installation
install -m 0640 docs/configuration/htmlm/*.html $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/configuration
install -m 0640 docs/programming/htmlm/*.html $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/programming
install -m 0640 docs/administration/htmlm/*.html $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/administration
install -m 0640 docs/manpages/htmlm/*.html $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/manpages
# part four - supporting images
install -m 0640 docs/userguide/images/*.jpg $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/userguide/images
install -m 0640 docs/userguide/images/*.png $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/userguide/images
install -m 0640 docs/userguide/icons/*.png $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/userguide/icons
install -m 0640 docs/userguide/icons/*.jpg $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/userguide/icons
install -m 0640 docs/userguide/icons/*.gif $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/userguide/icons
install -m 0640 docs/installation/images/*.jpg $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/installation/images
install -m 0640 docs/installation/images/*.png $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/installation/images
install -m 0640 docs/configuration/images/*.jpg $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/configuration/images
install -m 0640 docs/configuration/images/*.png $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/configuration/images
install -m 0640 docs/programming/images/*.jpg $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/programming/images
install -m 0640 docs/programming/images/*.png $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/programming/images
install -m 0640 docs/programming/icons/*.png $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/programming/icons
install -m 0640 docs/administration/images/*.jpg $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/administration/images
install -m 0640 docs/administration/images/*.png $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/administration/images
install -m 0640 docs/manpages/images/*.jpg $RPM_BUILD_ROOT%{_datadir}/%{name}/doc/html/manpages/images
# part five - READMEs
install -d $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 0640 install/README.%{distid} $RPM_BUILD_ROOT%{_datadir}/%{name}/README.%{distid}
install -m 0640 install/README.database $RPM_BUILD_ROOT%{_datadir}/%{name}/README.database
install -m 0640 install/README.faults $RPM_BUILD_ROOT%{_datadir}/%{name}/README.faults

# make the cloned applications
# variants of wacsmodelpage
cp $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsmodelpage $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsmpthumbs
ed $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsmpthumbs << EOF
/thumbsmode
.s/thumbsmode=0/thumbsmode=1/p
w
q
EOF
cp $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsmodelpage $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsmpmini
ed $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsmpmini << EOF
/thumbsmode
.s/thumbsmode=0/thumbsmode=2/p
w
q
EOF
cp $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsmodelpage $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsmpfull
ed $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsmpfull << EOF
/thumbsmode
.s/thumbsmode=0/thumbsmode=3/p
w
q
EOF
# variants of wacsimgcats
cp $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsimgcats $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsvidcats
ed $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsvidcats << EOF
/opmode
.s/opmode=0/opmode=1/p
w
q
EOF
cp $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsimgcats $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsphotcats
ed $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsphotcats << EOF
/opmode
.s/opmode=0/opmode=2/p
w
q
EOF
# variant of wacsimglist
cp $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsimglist $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsvidlist
ed $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsvidlist << EOF
/vidmode
.s/vidmode=0/vidmode=1/p
w
q
EOF
# variant of wacsnewsets
cp $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsnewsets $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsnewvideo
ed $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsnewvideo << EOF
/vidmode
.s/vidmode=0/vidmode=1/p
w
q
EOF
# variant of wacsimgselect
cp $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsimgselect $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsvidselect
ed $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsvidselect << EOF
/opmode
.s/opmode=0/opmode=1/p
w
q
EOF
# variant of wacsshow
cp $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsshow $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsvidshow
ed $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsvidshow << EOF
/vidmode
.s/vidmode=0/vidmode=1/p
w
q
EOF
# variant of wacsindex
cp $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacsindex $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacspage
ed $RPM_BUILD_ROOT%{_datadir}/%{name}/cgi-bin/wacspage << EOF
/pagemode
.s/pagemode=0/pagemode=1/p
w
q
EOF
# variant of rungq
cp $RPM_BUILD_ROOT%{_bindir}/rungq $RPM_BUILD_ROOT%{_bindir}/runmp
ed $RPM_BUILD_ROOT%{_bindir}/runmp << EOF
/vidmode
.s/vidmode=0/vidmode=1/p
w
q
EOF
# sort out the docs link
( cd $RPM_BUILD_ROOT%{_datadir}/%{name}/html; ln -s ../doc/ docs )

%pre
getent group %wacs_group >/dev/null || groupadd -r %wacs_group
getent passwd %wacs_user >/dev/null || \
	useradd -m -g %wacs_group -r -c "WACS Files Owner" -s /bin/bash \
	%wacs_user >/dev/null 2>&1 || :
usermod -a -G %wacs_group %http_user >/dev/null 2>&1 || :

%post
# find the host name and put it into config file
HOSTNAME=`uname -n`
ed %{_sysconfdir}/%{name}.d/wacs.cfg << EOF
1,\$s/INSERT-SERVER-DOMAINNAME-HERE/$HOSTNAME/gp
w
q
EOF
# find the wacs user's home directory and put it into config file
# regexp nightmare: two double backslashes become one real one!
HOMEDIR=`getent passwd %wacs_user | cut -d: -f 6`
SUBSDIR=`getent passwd %wacs_user | cut -d: -f 6 | sed 's/\//\\\\\//g'`
ed %{_sysconfdir}/%{name}.d/wacs.cfg << EOF
1,\$s/INSERT-WACS-USER-HOMEDIR-HERE/$SUBSDIR/gp
w
q
EOF

# make sure content space exists in wacs user home directory and that
# the permissions are right
if [ -d $HOMEDIR ]; then
	chgrp -R %wacs_group $HOMEDIR
	chmod g+rwx $HOMEDIR
	chmod g+s $HOMEDIR
fi
if [ ! -d $HOMEDIR/images ]; then
	mkdir -p $HOMEDIR/images
	chgrp -R %wacs_group $HOMEDIR/images
	chmod -R ug+rwX $HOMEDIR/images
	chmod g+s $HOMEDIR/images
fi
if [ ! -d $HOMEDIR/videos ]; then
	mkdir -p $HOMEDIR/videos
	chgrp -R %wacs_group $HOMEDIR/videos
	chmod -R ug+rwX $HOMEDIR/videos
	chmod g+s $HOMEDIR/videos
fi

# restart the httpd service configuration - this is so that the group id
# addition will be picked up by the web server (if we've just added the
# web server user to the wacs group).
service httpd restart

# start the database services as well
service mysqld start

# Since Wacs absolutely won't work without the web server and mysql server,
# it seems pretty pointless not to set those to start automatically.

%files
%defattr(0640,wacs,wacs)
%{_datadir}/%{name}/README.%{distid}
%{_datadir}/%{name}/README.database

# database stuff
%{_datadir}/%{name}/creation/MySQL5/mysql_*.sql
%{_datadir}/%{name}/creation/MySQL5/create_mysql.sql
%{_datadir}/%{name}/creation/Oracle10/ora_*.sql
%{_datadir}/%{name}/creation/Oracle10/create_oracle.sql

%package core
Summary: WACS Adult Web Site Toolkit - Core Libraries And Web Apps
Group: Applications/Publishing
Requires: httpd >= 2
Requires: perl
Requires: perl(DBI)

%description -n wacs-core
WACS Core contains the runtime routines for operating a web server -
it contains all an internet-facing server needs IF you are doing 
database and collection maintenance on another machine.  To update
and create a collection, you also need wacs-tools.

%pre -n wacs-core
getent group %wacs_group >/dev/null || groupadd -r %wacs_group
getent passwd %wacs_user >/dev/null || \
	useradd -m -g %wacs_group -r -c "WACS Files Owner" -s /bin/bash \
	%wacs_user >/dev/null 2>&1 || :
usermod -a -G %wacs_group %http_user >/dev/null 2>&1 || :

%files -n wacs-core
%defattr(2770,wacs,wacs)
%dir %{_datadir}/%{name}/
%dir %{_datadir}/%{name}/html
%dir %{_datadir}/%{name}/html/glyphs
%dir %{_datadir}/%{name}/html/glyphs/controls
%dir %{_datadir}/%{name}/html/glyphs/flags
%dir %{_datadir}/%{name}/html/glyphs/frames
%dir %{_datadir}/%{name}/html/styles
%dir %{_datadir}/%{name}/html/images
%dir %{_datadir}/%{name}/cache
%dir %{_datadir}/%{name}/cgi-bin
%dir %{_datadir}/%{name}/creation
%dir %{_datadir}/%{name}/creation/MySQL5
%dir %{_datadir}/%{name}/creation/Oracle10
%dir %{_datadir}/%{name}/utils
%dir %{_datadir}/%{name}/doc

%defattr(0755,root,root)
%dir %{_mandir}/man1

%defattr(0660,wacs,wacs)
%{_datadir}/%{name}/html/glyphs/*.png
%{_datadir}/%{name}/html/glyphs/controls/*.png
%{_datadir}/%{name}/html/glyphs/flags/*.jpg
%{_datadir}/%{name}/html/glyphs/frames/*.png
%{_datadir}/%{name}/html/styles/*.css
%{_datadir}/%{name}/html/styles/*.gif
%{_datadir}/%{name}/html/index.html
%{_datadir}/%{name}/html/csshorizontalmenu.js
%{_datadir}/%{name}/html/images/*.png
%{_datadir}/%{name}/html/images/*.jpg
%{_datadir}/%{name}/README.faults
%{_datadir}/%{name}/html/docs
%{_datadir}/%{name}/doc/index.html
%{_mandir}/man1/rungq.1*
%{_mandir}/man1/runmp.1*

%defattr(2770,wacs,wacs)
%dir %{_datadir}/%{name}/html/addicons/
%dir %{_datadir}/%{name}/html/icons/
%dir %{_datadir}/%{name}/html/bigicons/
%dir %{_datadir}/%{name}/cache/iconcache/
%dir %{_datadir}/%{name}/cache/officons/
%dir %{_datadir}/%{name}/cache/seticons/
%dir %{_datadir}/%{name}/cache/vidicons/
%dir %{_datadir}/%{name}/cache/dvdicons/
%dir %{_datadir}/%{name}/cache/thumbs/
%dir %{_datadir}/%{name}/cache/minithumbs/
%dir %{_datadir}/%{name}/cache/scaled/

%defattr(0750,wacs,wacs)
# from retrieval
%{_datadir}/%{name}/cgi-bin/wacsimg
%{_datadir}/%{name}/cgi-bin/wacsframe
%{_datadir}/%{name}/cgi-bin/wacsfull
%{_datadir}/%{name}/cgi-bin/wacsindex
%{_datadir}/%{name}/cgi-bin/wacspage
%{_datadir}/%{name}/cgi-bin/wacsthumb
%{_datadir}/%{name}/cgi-bin/wacsusc2257
%{_datadir}/%{name}/cgi-bin/wacszip
# from index
%{_datadir}/%{name}/cgi-bin/wacsimglist
%{_datadir}/%{name}/cgi-bin/wacsimgcats
%{_datadir}/%{name}/cgi-bin/wacslistconn
%{_datadir}/%{name}/cgi-bin/wacslistphotog
%{_datadir}/%{name}/cgi-bin/wacsstats
%{_datadir}/%{name}/cgi-bin/wacsvidcats
%{_datadir}/%{name}/cgi-bin/wacsvidlist
%{_datadir}/%{name}/cgi-bin/wacsphotcats
# from models
%{_datadir}/%{name}/cgi-bin/wacsmodelpage
%{_datadir}/%{name}/cgi-bin/wacsmodelthumbs
%{_datadir}/%{name}/cgi-bin/wacsmodelindex
%{_datadir}/%{name}/cgi-bin/wacsmpthumbs
%{_datadir}/%{name}/cgi-bin/wacsmpmini
%{_datadir}/%{name}/cgi-bin/wacsmpfull
# from presentation
%{_datadir}/%{name}/cgi-bin/wacsfp
%{_datadir}/%{name}/cgi-bin/wacsnewmodels
%{_datadir}/%{name}/cgi-bin/wacsnewsets
%{_datadir}/%{name}/cgi-bin/wacsshow
%{_datadir}/%{name}/cgi-bin/wacsslideshow
%{_datadir}/%{name}/cgi-bin/wacsnewvideo
%{_datadir}/%{name}/cgi-bin/wacsvidshow
# from search
%{_datadir}/%{name}/cgi-bin/wacsimgselect
%{_datadir}/%{name}/cgi-bin/wacsmodelselect
%{_datadir}/%{name}/cgi-bin/wacsvidselect
# from security
%{_datadir}/%{name}/cgi-bin/wacslogin
%{_datadir}/%{name}/cgi-bin/wacslogout
%{_datadir}/%{name}/cgi-bin/wacspref
# from tag
%{_datadir}/%{name}/cgi-bin/wacsaddtag
%{_datadir}/%{name}/cgi-bin/wacsdeltag
%{_datadir}/%{name}/cgi-bin/wacslisttags
%{_datadir}/%{name}/cgi-bin/wacsmarktag
%{_datadir}/%{name}/cgi-bin/wacstagsets
# from utils
%{_bindir}/rungq
%{_bindir}/runmp

%defattr(0770,wacs,wacs)
%{perlmodule}/Wacs.pm
%{perlmodule}/Wacs/Wacs*.pm

%defattr(0660,wacs,wacs)
%config(noreplace) %{_sysconfdir}/%{name}.d/wacs.cfg
%config(noreplace) %{_sysconfdir}/%{name}.d/wacs.acl
%config(noreplace) %{_sysconfdir}/%{name}.d/menu.cfg
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf

%defattr(2770,wacs,wacs)
%dir %{_localstatedir}/run/%{name}/

%package tools
Summary: WACS Adult Web Site Toolkit - Administration Tools
Group: Applications/Publishing
Requires: %{name}-core >= %{version}

%description -n wacs-tools
These are the collection administration tools for managing image
sets and video clips within the Wacs system.  If you want to build
your own system, at least one machine will need these but it need
not be your internet facing web server.

%pre -n wacs-tools
getent group %wacs_group >/dev/null || groupadd -r %wacs_group
getent passwd %wacs_user >/dev/null || \
	useradd -m -g %wacs_group -r -c "WACS Files Owner" -s /bin/bash \
	%wacs_user >/dev/null 2>&1 || :
usermod -a -G %wacs_group %http_user >/dev/null 2>&1 || :

%files -n wacs-tools
%defattr(0770,wacs,wacs)
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/cgi-bin
%dir %{_datadir}/%{name}/utils

%defattr(0755,root,root)
%dir %{_mandir}/man1

%defattr(0750,wacs,wacs)
# from tools
%{_bindir}/addassoc
%{_bindir}/addmodel
%{_bindir}/delset
%{_bindir}/generate
%{_bindir}/genvideo
%{_bindir}/updateinfo
%{_bindir}/updatestats
# from manage
%{_datadir}/%{name}/cgi-bin/wacsconnmgr
%{_datadir}/%{name}/cgi-bin/wacsdnllist
%{_datadir}/%{name}/cgi-bin/wacsdnlmgr
%{_datadir}/%{name}/cgi-bin/wacsinfomgr
%{_datadir}/%{name}/cgi-bin/wacskeywordmgr
%{_datadir}/%{name}/cgi-bin/wacsmodelmgr
%{_datadir}/%{name}/cgi-bin/wacsphotmgr
%{_datadir}/%{name}/cgi-bin/wacsplacemgr
%{_datadir}/%{name}/cgi-bin/wacssetmgr
%{_datadir}/%{name}/cgi-bin/wacsunpackmgr
%{_datadir}/%{name}/cgi-bin/wacsaddassoc
%{_datadir}/%{name}/cgi-bin/wacsvendmgr
%{_datadir}/%{name}/cgi-bin/wacsusermgr
%{_datadir}/%{name}/cgi-bin/wacsuserlist
# from migrate
%{_bindir}/wacsimport
%{_bindir}/wacsexport
%{_bindir}/wacsxmlin
%{_bindir}/wacsxmlout
%{_bindir}/wacsselin
%{_bindir}/wacsselout
# from populate
%{_datadir}/%{name}/utils/wacspop
# from install
%{_datadir}/%{name}/cgi-bin/wacssetup
%{_datadir}/%{name}/utils/upgrade

%defattr(0660,wacs,wacs)
%{_mandir}/man1/wacsexport.1*
%{_mandir}/man1/wacsimport.1*
%{_mandir}/man1/wacsxmlin.1*
%{_mandir}/man1/wacsxmlout.1*
%{_mandir}/man1/wacsselin.1*
%{_mandir}/man1/wacsselout.1*

%package -n wacs-download
Summary: WACS Adult Web Site Toolkit - Download Tools
Group: Applications/Publishing

%description -n wacs-download
The wacs-download package contains the various tools used for automatic
downloads from a web site.  If you're using WACS to host your own content
or just store what you've found on the wild internet, this probably won't
be much use.  If you do want to use the subscription-based pull technology,
then this is for you.

%pre -n wacs-download
getent group %wacs_group >/dev/null || groupadd -r %wacs_group
getent passwd %wacs_user >/dev/null || \
	useradd -m -g %wacs_group -r -c "WACS Files Owner" -s /bin/bash \
	%wacs_user >/dev/null 2>&1 || :
usermod -a -G %wacs_group %http_user >/dev/null 2>&1 || :

%files -n wacs-download 
%defattr(0750,wacs,wacs)
%{_bindir}/getarc
%{_bindir}/refresh
%{_bindir}/chkmodel
%{_datadir}/%{name}/cgi-bin/wacsdnlnext
%{_datadir}/%{name}/cgi-bin/wacsdnlframe
%{_datadir}/%{name}/cgi-bin/wacsdnlcomp

%defattr(2770,wacs,wacs)
%dir %{_localstatedir}/spool/%{name}/download
%dir %{_localstatedir}/spool/%{name}/archive

%package -n wacs-samples
Summary: WACS Adult Web Site Toolkit - Sample Files
Group: Applications/Publishing

%description -n wacs-samples
The wacs-samples package contains some sample database contents and some
example program code using the Perl API for the WACS system.  This includes
some sample vendor, photographer and keywords data for pre-loading into the
appropriate WACS tables.  It also includes a few sample model records which
can be loaded also, and source code to the example programs discussed in
the programming guide.  It doesn't include any photosets or video clips I'm
afraid as those would likely offend some people; those may be available from
the WACS demo site.

%pre -n wacs-samples
getent group %wacs_group >/dev/null || groupadd -r %wacs_group
getent passwd %wacs_user >/dev/null || \
	useradd -m -g %wacs_group -r -c "WACS Files Owner" -s /bin/bash \
	%wacs_user >/dev/null 2>&1 || :
usermod -a -G %wacs_group %http_user >/dev/null 2>&1 || :

%files -n wacs-samples
%defattr(0770,wacs,wacs)
%dir %{_datadir}/%{name}

%defattr(2770,wacs,wacs)
%dir %{_datadir}/%{name}/samples
%dir %{_datadir}/%{name}/samples/database/
%dir %{_datadir}/%{name}/samples/models/
%dir %{_datadir}/%{name}/samples/perl/
%dir %{_datadir}/%{name}/samples/junkyard/

%defattr(0660,wacs,wacs)
%{_datadir}/%{name}/samples/database/*.xml
%{_datadir}/%{name}/samples/models/*.xml
%{_datadir}/%{name}/samples/perl/*
%{_datadir}/%{name}/samples/README.samples
%{_datadir}/%{name}/samples/junkyard/README
%{_datadir}/%{name}/samples/junkyard/WHATSHERE

%defattr(0770,wacs,wacs)
%{_datadir}/%{name}/samples/junkyard/spinner
%{_datadir}/%{name}/samples/junkyard/remcopy
%{_datadir}/%{name}/samples/junkyard/conngraph
%{_datadir}/%{name}/samples/junkyard/fixdnl
%{_datadir}/%{name}/samples/junkyard/compare

%package -n wacs-doc-pdf
Summary: WACS Adult Web Site Toolkit - Documentation (PDF)
Group: Applications/Publishing

%description -n wacs-doc-pdf
The wacs-doc package contains the extensive documentation for the WACS
system in PDF format.  This includes the User Guide, The Installation
Guide, The Configuraion Guide and The Programming Guide.

%pre -n wacs-doc-pdf
getent group %wacs_group >/dev/null || groupadd -r %wacs_group
getent passwd %wacs_user >/dev/null || \
	useradd -m -g %wacs_group -r -c "WACS Files Owner" -s /bin/bash \
	%wacs_user >/dev/null 2>&1 || :
usermod -a -G %wacs_group %http_user >/dev/null 2>&1 || :

%files -n wacs-doc-pdf
%dir %{_datadir}/%{name}/
%dir %{_datadir}/%{name}/doc/
%dir %{_datadir}/%{name}/doc/pdf/

%defattr(0660,wacs,wacs)
%{_datadir}/%{name}/doc/pdf/*.pdf

%package -n wacs-doc-html
Summary: WACS Adult Web Site Toolkit - Documentation (HTML)
Group: Applications/Publishing

%description -n wacs-doc-html
The wacs-doc package contains the extensive documentation for the WACS
system in HTML formats - single page and multiple page.  This includes the
User Guide, The Installation Guide, The Configuraion Guide and The
Programming Guide.  

%pre -n wacs-doc-html
getent group %wacs_group >/dev/null || groupadd -r %wacs_group
getent passwd %wacs_user >/dev/null || \
	useradd -m -g %wacs_group -r -c "WACS Files Owner" -s /bin/bash \
	%wacs_user >/dev/null 2>&1 || :
usermod -a -G %wacs_group %http_user >/dev/null 2>&1 || :

%files -n wacs-doc-html
%defattr(0770,wacs,wacs)
%dir %{_datadir}/%{name}/doc/
%dir %{_datadir}/%{name}/doc/html/
%dir %{_datadir}/%{name}/doc/html/userguide/
%dir %{_datadir}/%{name}/doc/html/installation/
%dir %{_datadir}/%{name}/doc/html/configuration/
%dir %{_datadir}/%{name}/doc/html/programming/
%dir %{_datadir}/%{name}/doc/html/administration/
%dir %{_datadir}/%{name}/doc/html/manpages/

%defattr(0660,wacs,wacs)
%{_datadir}/%{name}/doc/html/userguide/*.html
%{_datadir}/%{name}/doc/html/userguide/icons/*.jpg
%{_datadir}/%{name}/doc/html/userguide/icons/*.gif
%{_datadir}/%{name}/doc/html/userguide/icons/*.png
%{_datadir}/%{name}/doc/html/userguide/images/*.jpg
%{_datadir}/%{name}/doc/html/userguide/images/*.png
%{_datadir}/%{name}/doc/html/installation/*.html
%{_datadir}/%{name}/doc/html/installation/images/*.jpg
%{_datadir}/%{name}/doc/html/installation/images/*.png
%{_datadir}/%{name}/doc/html/configuration/*.html
%{_datadir}/%{name}/doc/html/configuration/images/*.jpg
%{_datadir}/%{name}/doc/html/configuration/images/*.png
%{_datadir}/%{name}/doc/html/programming/*.html
%{_datadir}/%{name}/doc/html/programming/icons/*.png
%{_datadir}/%{name}/doc/html/programming/images/*.jpg
%{_datadir}/%{name}/doc/html/programming/images/*.png
%{_datadir}/%{name}/doc/html/administration/*.html
%{_datadir}/%{name}/doc/html/administration/images/*.jpg
%{_datadir}/%{name}/doc/html/administration/images/*.png
%{_datadir}/%{name}/doc/html/manpages/*.html
%{_datadir}/%{name}/doc/html/manpages/images/*.jpg

%changelog
* Sun Mar 27 2011 Beaky <wacs@beaky.name> - 0.8.5.80-1
- relocated the wacs perl modules to /usr/share/perl5 and gave them their
  own subdirectory.

* Tue Mar 16 2010 Beaky <wacs@beaky.name> - 0.8.4.90-1
- tided up in build for first release client
- added manpages to the spec file.

* Fri Mar 12 2010 Beaky <wacs@beaky.name> - 0.8.4.80-3
- added manpages documentataion

* Fri Jan 22 2010 Beaky <wacs@beaky.name> - 0.8.4.80-2
- added wacsuserlist command
- added wacspage - clone of wacsindex with selectable alternative menu feature

* Mon Dec 21 2009 Beaky <wacs@beaky.name> - 0.8.4.80-1
- added wacsusermgr command

* Wed Apr  1 2009 Beaky <wacs@beaky.name> - 0.8.4-1
- added wacssetup and wacsaddassoc commands

* Thu Jan 29 2009 Beaky <wacs@beaky.name> - 0.8.3-2
- added upgrade command into utils directory

* Sat Jan 10 2009 Beaky <wacs@beaky.name> - 0.8.3-1
- added support for caching of scaled icons via scalecache
- added junkyard items into the samples package
- added administration documents into the docs packages

* Sat Aug 23 2008 Beaky <wacs@beaky.name> - 0.8.1-1
- added user add test to all sub-packages in case they are installed first
- added required directory trees/permissions to sub-packages

* Thu Aug 21 2008 Beaky <wacs@beaky.name> - 0.8.1-1
- included the perl API sample programs
- sorted out the documentation parts of the packages.

* Tue Aug 19 2008 Beaky <wacs@beaky.name> - 0.8.1-1
- added post install scriptlet to configure the hostname in config files
- added release specific index.html file
- added populate utils into share area
- built tree of cache directories in share area
- built tree of web-site icon areas in share tree
- make sure it owns everything under share area (nearly there)
- went mad with sed and backslashes until something worked!

* Wed Aug  6 2008 Beaky <wacs@beaky.name> - 0.8.1-1
- renamed -doc to -doc-pdf
- added -download with appropriate components

* Tue Aug  5 2008 Beaky <wacs@beaky.name> - 0.8.1-1
- added in the creation SQL scripts
- added in the samples and populate XML files into new Samples RPM
- put some actual content into the tools package

* Fri Jul 25 2008 Beaky <wacs@beaky.name> - 0.8.1-1
- moved hostauth to separate spec file

* Wed Jul 23 2008 Beaky <wacs@beaky.name> - 0.8.1-1
- Initial bones created
- five initial packages created: wacs, wacs-core, wacs-tools, and wacs-doc
