#
#    WacsUI.PM - user interface components perl modules
#
#    (C) Copyright 2007,2008,2009,2010,2011 B King
#    This file is part of WACS.
#
#    WACS is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 3 of the License, or
#    (at your option) any later version.
#
#    WACS is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with WACS.  If not, see <http://www.gnu.org/licenses/>.
#

package Wacs::WacsUI;

require Exporter;
use XML::Simple;
use Data::Dumper;

@ISA 		= qw(Exporter);
@EXPORT 	= qw(describeher whatshedoes addkeyicons addratings
		     iconlink addlinks alsofeaturing
                     read_menu menu_get_default menu_get_title menu_get_body
		     menu_get_handler);

# global variables used in this module
$main_menu="menu.cfg";
$this_menu='';
$menuhandle='';

# set the debug level
$debug=Wacs::conf_get_attr("debug","module_wacsui");

# 
# describeher
#
# make a readable sentance from the model descriptive data fields
sub describeher( % )
{
	my( %params )=@_;
	my( $name, $hometown, $country, $age, $ageyear );
	my( $hair, $length, $titsize, $cupsize, $pussy, $race, $eyes );
	my( $distmarks, $build, $height, $weight, $vitbust, $vitwaist );
	my( $vithips, $occupation, $aliases, $bio, $units );
	my( $desc );

	# copy across from named parameters
	$name=$params{'name'};
	$hometown=$params{'hometown'};
	$country=$params{'country'};
	$age=$params{'age'};
	$ageyear=$params{'ageyear'};
	$hair=$params{'hair'};
	$length=$params{'length'};
	$titsize=$params{'titsize'};
	$cupsize=$params{'cupsize'};
	$pussy=$params{'pussy'};
	$race=$params{'race'};
	$eyes=$params{'eyes'};
	$distmarks=$params{'distmarks'};
	$build=$params{'build'};
	$height=$params{'height'};
	$weight=$params{'weight'};
	$vitbust=$params{'vitbust'};
	$vitwaist=$params{'vitwaist'};
	$vithips=$params{'vithips'};
	$occupation=$params{'occupation'};
	$aliases=$params{'aliases'};
	$bio=$params{'bio'};
	$units=$params{'units'};
	if( $units eq "" )
	{
		$units = Wacs::conf_get_attr("layout","units");
	}
	$desc='';

	if( $name ne "" )
	{
		# must have some values to make this sentence
		if( $hometown ne "" || $country ne "" || $age ne "" )
		{
			$desc = $name." ";
			if( $country ne "" )
			{
				# country specified, what about hometown?
				$desc .= "comes from ";
				if( $homedown ne "" )
				{
					$desc .= $hometown." in ";
				}
				if( $country eq "UK" || $country eq "USA" ||
				    $country eq "Czech Republic" ||
				    $country eq "Ukraine" )
				{
					$desc .= "the ".$country." ";
				}
				elsif( $country ne "" )
				{
					$desc .= $country." ";
				}
			}
			else
			{
				# country wasn't specified, but was hometown?
				if( $hometown ne "" )
				{
					$desc .= "comes from ".$hometown." ";
				}
			}
			if( $age ne "" )
			{
				# did we add any hometown or country info?
				if( $desc ne $name." " )
				{
					$desc .= "and ";
				}
				$desc .= "was ".$age." years old ";
				if( $ageyear ne "" )
				{
					$desc .= "in ".$ageyear." ";
				}
				$desc .= 
				  "when the first pictures here were taken";
			}
			# trim any trailing space, add full stop, and start new
			# sentence.
			$desc =~ s/\s$//;
			$desc .= ".  ";
		}
		# end of basic introduction sentence
	}
	$desc .= 'She has ';
	if( $race ne "" )
	{
		$desc .= " a";
		if( $race eq "Oriental" || $race eq "Asian" || 
			$race eq "Aboriginal" )
		{
			$desc .= "n ".lc($race)." complexion, ";
		}
		else
		{
			$desc .= " ".lc($race)." complexion, ";
		}
	}
	if( $length ne "" )
	{
		$desc .= lc( $length );
		if( $length eq "Normal" )
		{
			$desc .= " length";
		}
	}
	if( $hair ne "" )
	{
		$desc .= " ".lc( $hair );
		if( $hair ne "Dark Hair")
		{
			$desc .= " hair";
		}
		$desc .= ", ";
	}
	if( $eyes ne "" )
	{
		$desc .= lc( $eyes )." eyes, ";
	}
	if( $titsize ne "" )
	{
        	$desc .= lc( $titsize )." breasts";
	}
	if( $cupsize ne "" && $cupsize ne "N" )
	{
		$desc .= " (".$cupsize."-cup)";
	}
	if( $pussy ne "" )
	{
		if( $pussy eq "S" )
		{	
			$desc .= " and a shaven pussy";
		}
		if( $pussy eq "B" )
		{
			$desc .= " and a Brazilian shaved pussy";
		}
		if( $pussy eq "T" )
		{
			$desc .= " and a trimmed pussy";
		}
		if( $pussy eq "H" )
		{
			$desc .= " and a hairy pussy";
		}
		if( $pussy eq "V" )
		{
			$desc .= " and her pussy varies";
		}
	}
	if( $distmarks ne "" )
	{
		$desc .= " and can be recognised by ".$distmarks;
	}
	$desc .= ".";
	if( $build ne "" )
	{
		$desc .= "  She is of ";
		if( $build eq "V" )
		{
			$desc .= "very slim build";
		}
		if( $build eq "S" )
		{
			$desc .= "slim build";
		}
		if( $build eq "M" )
		{
			$desc .= "medium build";
		}
		if( $build eq "H" )
		{
			$desc .= "heavy build";
		}
		if( $height ne "" && $height ne "0" )
		{
			if( $units eq "imperial" )
			{
				$desc .= " and is ".int (($height/2.54)/12).
					"ft ".((($height/2.54)%12)+1).
					"in tall";
			}
			else
			{
				$desc .= " and is ".$height."cm tall";
			}
		}
		if( $weight ne "" && $weight ne "0" )
		{
			if( $units eq "imperial" )
			{
				$desc .= ", and weighs ".int ($weight*2.2)."lbs";
			}
			else
			{
				$desc .= ", and weighs ".$weight." kilos";
			}
		}
		$desc .= ". ";
	}
	elsif( $height ne "" && $height ne "0" )
	{
		if( $units eq "imperial" )
		{
			$desc .= "  She is ".int (($height/2.54)/12)."ft ".
                                        ((($height/2.54)%12)+1)."in tall";
		}
		else
		{
			$desc .= "  She is ".$height."cm tall";
		}
		if( $weight ne "" && $weight ne "0" )
                {
			if( $units eq "imperial" )
			{
				$desc .= " and weighs ".int ($weight*2.2).
					" lbs.";
			}
			else
			{
				$desc .= " and weighs ".$weight." kilos.";
			}
                }
	}
	elsif( $weight ne "" && $weight ne "0" )
	{
		if( $units eq "imperial" )
		{
			$desc .= "  She weighs ".int ($weight*2.2)." lbs.";
		}
		else
		{
			$desc .= "  She weighs ".$weight." kilos.";
		}
	}
	if( ($vitbust ne "" && $vitbust ne "0") ||
	    ($vitwaist ne "" && $vitwaist ne "0") ||
	    ($vithips ne "" && $vithips ne "0" ) )
	{
		# sort out which unit type
		if( $units eq "imperial" )
		{
			# do we have all three values?
			if( $vitbust > 0 && $vitwaist > 0 && $vithips > 0 )
			{
				# yes
				$desc .= "  Her vital statistics are ".
					int (($vitbust/2.54)+0.499)."-".
					int (($vitwaist/2.54)+0.499)."-".
					int (($vithips/2.54)+0.499)." inches.";
			}
			else
			{
				# no, we don't, so it's bust plus either of
				# the others...
				if( $vitbust > 0 )
				{
					$desc .= "  Her bust is ".
						int (($vitbust/2.54)+0.499).
						" inches";
				}
				else
				{
					$desc .= "  Her bust measurement ".
						"wasn't given";
				}
				if( $vitwaist > 0 )
				{
					$desc .= " and her waist is ".
						int(($vitwaist/2.54)+0.499).
						" inches";
				}
				if( $vithips > 0 )
				{
					$desc .= " and her hips are ".
						int(($vithips/2.54)+0.499).
						" inches";
				}
				$desc.=".";
			}
		}
		else
		{
			# metric now: do we have all three values?
			if( $vitbust > 0 && $vitwaist > 0 && $vithips > 0 )
			{
				# yes
				$desc .= "  Her vital statistics are ".
					$vitbust."-".$vitwaist."-".$vithips.
					"cms.";
			}
			else
			{
				# no
				if( $vitbust > 0 )
				{
					$desc .= "  Her bust is ".$vitbust.
						" cms";
				}
				else
				{
					$desc .= "  Her bust measurement ".
						"wasn't given";
				}
				if( $vitwaist > 0 )
				{
					$desc .= " and her waist is ".
						$vitwaist." cms";
				}
				if( $vithips > 0 )
				{
					$desc .= " and her hips are ".
						$vithips." cms";
				}
				$desc .= ".";
			}
		}
	}
	if( $aliases ne "" )
	{
		$desc .= "  She is also sometimes known as ".$aliases.".";
	}
	if( $occupation ne "" )
	{
		if( $occupation eq "Model" || $occupation eq "model" )
		{
			$desc .= "  She's a full time model.";
		}
		else
		{
			$desc .= "  When not modelling, she is a ".
				$occupation.".";
		}
	}
	if( $bio ne "" )
	{
		$desc .= "  ".$bio;
	}
	return( $desc );
}

# whatshedoes
#
# describing what kind of sets she does
sub whatshedoes( % )
{
	my( %params )=@_;
	my( $solo, $straight, $lesbian, $fetish, $toys, $masturbation, $other );
	my( $shedoes, $doescount );

	$solo=$params{'solo'};
	$straight=$params{'straight'};
	$lesbian=$params{'lesbian'};
	$fetish=$params{'fetish'};
	$toys=$params{'toys'};
	$masturbation=$params{'masturbation'};
	$other=$params{'other'};
	$shedoes='';

	$doescount=0;
	if( $solo eq "Y" )
	{
		$shedoes .= "Solo,";
		$doescount++;
	}
	if( $straight eq "Y" )
	{
		$shedoes .= " Straight,";
		$doescount++;
	}
	if( $lesbian eq "Y" )
	{
		$shedoes .= " Lesbian,";
		$doescount++;
	}
	if( $fetish eq "Y" )
	{
		$shedoes .= " Fetish,";
		$doescount++;
	}
	if( $toys eq "Y" )
	{
		$shedoes .= " Toys,";
		$doescount++;
	}
	if( $masturbation eq "Y" )
	{
		$shedoes .= " Masturbation,";
		$doescount++;
	}
	if( $other eq "Y" )
	{
		$shedoes .= " Other,";
		$doescount++;
	}
	$shedoes =~ s/^ //;
	$shedoes =~ s/ $//;
	$shedoes =~ s/,$//;
	if( $doescount == 1 )
	{
		$shedoes .= " only";
	}
	else
	{
		$shedoes =~ s/,\ ([A-z]*)$/ and $+/;
	}
	return( $shedoes );
}

#
# addkeyicons
#
# make a little box with the attribute icons in it
sub addkeyicons( $$ )
{
        my( $keylist, $iconsize )=@_;
        my( @words, $next );

        @words = split( /\s/, $keylist );
        print "<table class=\"addkeyicons\" bgcolor=\"#B070B0\"><tr><td>\n";
        while( $next = shift @words )
        {
                doicon( $next, $iconsize );
        }
        print "</td></tr></table>\n";
}

#
# doicon
#
# output reference to specific icon
sub doicon( $$ )
{
        my( $icon, $iconsize )=@_;
	my( %iconloc );

        #print "icon: $icon  file: $iconlist{$icon}\n";
	%iconloc = Wacs::geticonlist( "sets" );
        print "<img ";
        if( $iconsize != 0 )
        {
                print "width=$iconsize height=$iconsize ";
        }
        print "src=\"".Wacs::conf_get_attr("server","iconurl");
        print $iconloc{$icon};
        print "\">&nbsp;\n";
}

# addratings
#
# adds rating icons to the set
sub addratings( % )
{
	my( %params )=@_;
	my( $aroverall, $arvariety, $artechqual, $arsize, $arorient, $artitle );
	my( $iconurl );

	$aroverall=$params{'overall'};
	$arvariety=$params{'variety'};
	$artechqual=$params{'techqual'};
	$arsize=$params{'size'};
	$arorient=$params{'orientation'};
	$artitle=$params{'title'};
	$iconurl=Wacs::conf_get_attr("server","iconurl");

	if( $artitle eq "y" )
	{
		print "<table cellpadding=0 cellspacing=0 border=1>\n";
		print "<tr><th>Ratings:</th></tr>";
		print "<tr><td align=center>";
		print "<table cellpadding=0 cellspacing=0><tr>";
		print "<td align=right valign=top>Overall: ";
	}
	else
	{
		print "<table cellpadding=0 cellspacing=0>\n";
		print "<tr><td align=right valign=top>\n";
	}
	if( $aroverall > 0 )
	{
		print "<img align=top src=\"".$iconurl."icon4-".
			$aroverall.".png\" alt=[\"".$aroverall.
			"/5]";
		if( $arsize eq "small" )
		{
			print " width=43 height=12";
		}
		print "\"></td>\n";
	}
	else
	{
		if( $artitle eq "y" )
		{
			print "Not Rated</td>\n";
		}
		else
		{
			print "&nbsp;</td>\n";
		}
	}
	if( $arorient eq "vertical" )
	{
		print "</tr>\n";
	}
	if( $arvariety > 0 )
	{
		if( $arorient eq "vertical" )
		{
			print "<tr>\n";
		}
		print "<td align=right valign=top>";
		if( $artitle eq "y" )
		{
			print "Variety: ";
		}
		print "<img align=top src=\"".$iconurl.
			"icon5-".$arvariety.".png\" alt=[\"".
			$arvariety."/5]";
		if( $arsize eq "small" )
		{
			print " width=43 height=12";
		}
		print "\"></td>\n";
		if( $arorient eq "vertical" )
		{
			print "</tr>\n";
		}
	}
	else
	{
		if( $artitle eq "y" )
		{
			if( $arorient eq "vertical" )
			{
				print "<tr>\n";
			}
			print "<td>Variety: Not Rated</td>\n";
			if( $arorient eq "vertical" )
			{
				print "</tr>\n";
			}
		}
	}
	if( $artechqual > 0 )
	{
		if( $arorient eq "vertical" )
		{
			print "<tr>\n";
		}
		print "<td align=right valign=top>";
		if( $artitle eq "y" )
		{
			print "Quality: ";
		}
		print "<img align=top src=\"".$iconurl.
			"icon6-".$artechqual.".png\" alt=[\"".
			$artechqual."/5]";
		if( $arsize eq "small" )
		{
			print " width=43 height=12";
		}
		print "\"></td></tr>\n";
	}
	else
	{
		if( $artitle eq "y" )
		{
			print "<td align=right>Quality: Not Rated</td></tr>\n";
		}
		else
		{
			print "</tr>\n";
		}
	}
	if( $artitle eq "y" )
	{
		print "</table></td></tr></table>\n";
	}
	else
	{
		print "</table>\n";
	}
}

# 
# addlinks
#
# add standard system links to the page
sub addlinks( % )
{
        my( %params )=@_;
	my( $myname, $context, $title, $exclude, $mode, $options, $optdesc );
	my( $menulist, $nextmenu );

	# valid contexts are: image, video, search, new
	$myname=lc( $params{'myname'} );
	$context=lc( $params{'context'} );
	$title=$params{'title'};
	$exclude=lc( $params{'exclude'} );
	$mode=$params{'mode'};
	$options=$params{'options'};
	$optdesc=$params{'optdesc'};
	$menulist="search,navigation";
	if( exists $params->{'menulist'} )
	{
		$menulist=$params{'menulist'};
	}

	if( $mode eq "normal" )
	{
		addlinks_legacy( 'context'=>$context,
				  'exclude'=>$exclude );
	}
	elsif( $mode eq "csshoriz" )
	{
		read_menu( $main_menu );
		print "<table cellspacing=0 cellpadding=0 width=100%\n";
		print " text=\"#F0D8F0\" link=\"#F8F8D8\" vlink=\"#FFFFD0\" ";
		print " bgcolor=\"#000040\">\n";
		print "<tr><td>\n";
		print "<div class=\"horizontalcssmenu\">\n";
		print "<ul id=\"cssmenu1\">\n";

		# work out what the menus should be
		if( $context eq "modelindex" )
		{
			$menulist="alternatives,favourites,search,navigation";
		}
		elsif( $context eq "models" )
		{
			$menulist="favourites,search,navigation";
		}
		elsif( $context eq "search" )
		{
			$menulist="search,navigation";
		}
		elsif( $context eq "tags" )
		{
			$menulist="tagsalt,search,navigation";
		}
		elsif( $context eq "newimage" )
		{
			$menulist="newrelated,search,navigation";
		}
		elsif( $context eq "newvideo" )
		{
			$menulist="newrelated,search,navigation";
		}
		elsif( $context eq "admin" )
		{
			if( Wacs::auth_get_attr("ipv4-".$ENV{"REMOTE_ADDR"},
				"role") eq "admin" ) 
			{
				$menulist="admin,search,navigation";
			}
			else
			{
				$menulist="search,navigation";
			}
		}
			
		foreach $nextmenu ( split( /,/, $menulist) )
		{
			# ALTERNATIVES optional submenu
			if( $nextmenu eq "alternatives" )
			{
				print "<li style=\"".
					"border-left: 1px solid #202020;\">";
				print "<a href=\"".
					menu_get_default( name=>"alternatives",
						  caller=>$myname,
						  exclude=>$exclude,
						  options=>$options,
						  optdesc=>$optdesc )."\">";
				print "<font color=\"#F8F8D8\">".
					menu_get_title( name=>"alternatives" );
				print "</font></a>\n";
				print " <ul>\n";
				print menu_get_body( name=>"alternatives",
						caller=>$myname."/".$options,
						exclude=>$exclude,
						options=>$options,
						optdesc=>$optdesc );
				print " </ul></li>\n";
			}
			# NEWRELATED - optional submenu
			if( $nextmenu eq "newrelated" )
			{
				print "<li style=\"".
					"border-left: 1px solid #202020;\">";
				print "<a href=\"".
					menu_get_default( name=>"newrelated",
						  caller=>$myname,
						  exclude=>$exclude,
						  options=>$options )."\">";
				print "<font color=\"#F8F8D8\">".
					menu_get_title( name=>"newrelated" );
				print "</font></a>\n";
				print "<ul>\n";
				print menu_get_body( name=>"newrelated",
						caller=>$myname."/".$options,
						exclude=>$exclude,
						options=>$options );
				print " </ul></li>\n";
			}
			# FAVOURITES - optional submenu
			if( $nextmenu eq "favourites" )
			{
				print "<li style=\"".
					"border-left: 1px solid #202020;\">";
				print "<a href=\"".
					menu_get_default( name=>"favourites",
						  caller=>$myname,
						  exclude=>$exclude )."\">";
				print "<font color=\"#F8F8D8\">".
					menu_get_title( name=>"favourites" );
				print "</font></a>\n";
				print "<ul>\n";
				print menu_get_body( name=>"favourites",
						     caller=>$myname."/".
								$options,
						     exclude=>$exclude,
						     options=>$options );
				print "</ul></li>\n";
			}
			# SEARCH SUB-MENU
			if( $nextmenu eq "search" )
			{
				print "<li style=\"".
					"border-left: 1px solid #202020;\">";
				print "<a href=\"";
				print menu_get_default( name=>"search",
						caller=>$myname,
						exclude=>$exclude )."\">";
				print "<font color=\"#F8F8D8\">";
				print menu_get_title( name=>"search");
				print "</font></a>\n";
				print "<ul>\n";
				print menu_get_body( name=>"search",
					     caller=>$myname,
					     exclude=>$exclude );
				print " </ul></li>\n";
			}
			# NAVIGATION SUB-MENU
			if( $nextmenu eq "navigation" )
			{
				print "<li style=\"".
					"border-left: 1px solid #202020;\">";
				print "<a href=\"".
					menu_get_default(name=>"navigation",
						caller=>$myname,
					        exclude=>$exclude );
				print "\"><font color=\"#F8F8D8\">".
					menu_get_title(name=>"navigation").
					"</font></a>\n";
				print " <ul>\n";
				print menu_get_body( name=>"navigation",
					     caller=>$myname,
					     exclude=>$exclude );
				print " </ul></li>\n";
			}
			# tagsalt menu
			if( $nextmenu eq "tagsalt" )
			{
				print "<li style=\"".
					"border-left: 1px solid #202020;\">";
				print "<a href=\"".
					menu_get_default(name=>"tagsalt",
						caller=>$myname,
						exclude=>$exclude,
						options=>$options );
				print "\"><font color=\"#F8F8D8\">".
					menu_get_title(name=>"tagsalt").
					"</font></a>\n";
				print " <ul>\n";
				print menu_get_body( name=>"tagsalt",
					     caller=>$myname,
					     exclude=>$exclude,
					     options=>$options );
				print " </ul></li>\n";
			}
			# admin menu
			if( $nextmenu eq "admin" )
			{
				print "<li style=\"".
					"border-left: 1px solid #202020;\">";
				print "<a href=\"".
					menu_get_default(name=>"admin",
					        caller=>$myname,
						exclude=>$exclude,
						options=>$options );
				print "\"><font color=\"#F8F8D8\">".
					menu_get_title(name=>"admin").
					"</font></a>\n";
				print " <ul>\n";
				print menu_get_body( name=>"admin",
					        caller=>$myname,
					        exclude=>$exclude,
						options=>$options );
				print "</ul></li>\n";
			}			
		}
		print "</ul>\n";
		print "<br style=\"clear: left;\" />\n";
		print "</div>\n";
		print "</td></tr>\n";
		print "</table>\n";
	}
	else
	{
		print "addlinks: Unknown mode $mode\n";
	}
}

#
# addlinks_legacy
#
# support for legacy-style static menus
sub addlinks_legacy( % )
{
	my( %params )=@_;
	my( $allcontext, $allexclude );

	$allcontext = $params{'context'};
	$allexclude = $params{'exclude'};

	print "<table width=100%><tr>\n";
	print "<td align=left><a href=\"";
	print Wacs::conf_get_attr("server","cgiurl");
	if( $allcontext eq "search" )
	{
		if( $allexclude ne "wacslisttags" )
		{
			print "wacslisttags\">".
				"Saved Searches</a></td>\n";
		}
		else
		{
			print "wacsimgselect\">Image Search</a></td>\n";
		}
	}
	else
	{
		print "wacsnewmodels\">".
				"Recently Added Models</a></td>\n";
	}
	print "<td align=left><a href=\"".
		Wacs::conf_get_attr("server","cgiurl");
	if( $allcontext eq "video" )
	{
		if( $allexclude ne "wacsnewvideo" )
		{
			print "wacsnewvideo\">".
				"Recently Added Videos</a></td>\n";
		}
		else
		{
			print "wacsvidselect\">Video Search</a></td>\n";
		}
	}
	elsif( $allcontext eq "search" )
	{
		if( $allexclude ne "wacsimgselect" )
		{
			print "wacsimgselect\">Image Search</a></td>\n";
		}
		else
		{
			print "wacsmodelselect\">".
				"Model Select</a></td>\n";
		}
	}
	else
	{
		if( $allexclude ne "wacsnewsets" )
		{
			print "wacsnewsets\">".
				"Recently Added Sets</a></td>\n";
		}
		else
		{
			print "wacsvidselect\">Video Search</a></td>\n";
		}
	}
	print "<td><a href=\"".Wacs::conf_get_attr("server","wacsallm");
	print "\">All Models</a></td>\n";
	print "<td align=right><a href=\"".
			Wacs::conf_get_attr("server","wacsmain");
	print "\">Main Index</a></td>\n";
	print "</tr></table>\n";
}

#
# iconlink
#
#
sub iconlink( % )
{
        my %params = @_;
        my( $type, $model, $setno, $sarea, $scategory, $sdirectory, $sresize );
	my( $destapp, $destext, $destloc );
	my( $size, $extension, $iconloc, $typeloc );

	$destext=".html";
        $type = $params{"type"};
        $setno = $params{"setno"};
        $sarea = $params{"sarea"};
        $scategory = $params{"scategory"};
        $sdirectory = $params{"sdirectory"};
        $model = $params{"model"};
	$sresize = $params{"resize"};
	$destloc = $params{"destloc"};
	$destapp = $params{"destapp"};
	# the extension could well be a null string intentionally
	if( exists( $params{"destext"} ))
	{
		$destext = $params{"destext"};
	}
	# if we're not told otherwise, we expect it in the cgi-bin directory
	if( $destloc eq "" )
	{
		$destloc = "cgiurl";
	}

        if( $type eq "I" )
        {
		if( $destapp eq "" )
		{
			$destapp = "wacsindex/page";
		} 
                print "<a href=\"".Wacs::conf_get_attr("server",$destloc);
                print $destapp.$setno.$destext."\">";

		# preliminary support for usedirect - this is where the
		# actual path to the icon within the web tree is given
		# instead of the url of wacsimg - faster but visible name
		# and gets cached....
		if( Wacs::auth_get_attr("ipv4-".$ENV{"REMOTE_ADDR"},"usedirect")
		    eq "yes" && $sresize < 2 )
		{
			# without directurl, server is not configured for
			# operation with usedirect.
			$iconloc = Wacs::conf_get_attr("server","directurl");
			if( $iconloc ne "" && $sarea ne "" )
			{
				$typeloc = 
					Wacs::conf_get_attr("fsloc","seticons");
				# regex here to find final path component.
				while( $typeloc =~ /[A-Za-z0-9_\-,. ]\// )
				{
					$typeloc =~
			s/^(\/[A-Za-z0-9_\-,. ]+)([A-Za-z0-9_\-,. \/]+)$/\2/;
				}
				if( $typeloc ne "" && $typeloc ne "/" )
				{
					print "<img src=\"".$iconloc.$typeloc.
					  "/".$sarea."/".$scategory."/".
					  $sdirectory.".jpg\" alt=\"$model\">";
				}
				else
				{
					print "<img src=\"".$iconloc.
					  "/".$sarea."/".$scategory."/".
					  $sdirectory.".jpg\" alt=\"$model\">";
				}
				return;
			}
		}

		# usedirect case didn't happen, default behaviour
		print "<img src=\"".Wacs::conf_get_attr("server","cgiurl");
		if( $sresize == 0 )
		{
			print "wacsimg/set$setno.jpg\" ";
		}
		elsif( $sresize == 1 )
		{
			print "wacsimg/std$setno.jpg\" ";
		}
		else
		{
			print "wacsimg/mini$setno.jpg\" ";
		}
                print "alt=\"$model\">";
        }
        if( $type eq "V" )
        {
                $extension = '';
                if( $sdirectory =~ /.wmv$/ )
		{
			$extension = '.wmv';
		}
		elsif( $sdirectory =~ /.mpg$/ )
		{
			$extension = '.mpg';
		}
		elsif( $sdirectory =~ /.mov$/ )
		{
			$extension = '.mov';
		}
		else
		{
			$extension = '.avi';
		}
		# if the extension specified is null, remove whatever
		# we guessed it to be
		if( $destext eq "" )
		{
			$extension = '';
		}
		if( $destapp eq "" )
		{
			$destapp = "wacszip/set";
		} 
                print "<a href=\"".Wacs::conf_get_attr("server",$destloc);
                print $destapp.$setno.$extension."\">";
		# FIXME: add usedirect support here
                print "<img src=\"".Wacs::conf_get_attr("server","cgiurl");
		if( $sresize == 0 )
                {
                        print "wacsimg/set$setno.jpg\" ";
                }
                elsif( $sresize == 1 )
                {
                        print "wacsimg/std$setno.jpg\" ";
                }
		else
		{
			print "wacsimg/mini$setno.jpg\" ";
		}
                print "alt=\"$model\">";
        }
}

#
# alsofeaturing
#
# look for any other models also featuring in this set
sub alsofeaturing( % )
{
        my %params = @_;
        my( $setno, $primary, $staysmall, $destloc, $linkto, $skipbr );
	my( $alsotit, $alsosql, $alsocsr, @alsorec );
	my( $dbhandle, $afsep );

        $setno = $params{"setno"};
        $primary = $params{"primary"};
        $staysmall = $params{"staysmall"};
	$destloc = $params{"destloc"};
        $linkto = $params{"linkto"};
	$skipbr = $params{"skipbr"};
	$dbhandle = $params{"dbhandle"};
	$afsep = '/';
	if( $destloc eq "" )
	{
		$destloc = "cgiurl";
	}
	# check for it ending in equals as in modelno= or L=
	if( $linkto =~ /=$/ )
	{
		$afsep = '';
	}

        $alsotit = 0;
        $alsosql = "select modelno, mname ".
        	   "from ".Wacs::conf_get_attr("tables","models").
		   ", ".Wacs::conf_get_attr("tables","assoc")." ".
        	   "where amodelno = modelno ".
        	   "and asetno = '".$setno."' ".
		   "order by mname ";
        $alsocsr = $dbhandle->prepare( $alsosql );
        $alsocsr->execute;
        while( @alsorec = $alsocsr->fetchrow_array )
        {
                if( $alsorec[0] ne $primary )
                {
			if( $alsotit == 0 )
                        {
				if( $skipbr ne "first" && $skipbr ne "all" )
				{
					print "<br>";
				}
				print "<span class=\"alsofeattitle\">".
					"<font size=-2>";
                                if( $primary ne "" )
                                {
                                        print "Also ";
                                }
                                print "featuring:";
                                if( $staysmall ne "Y" )
                                {
                                        print "</font>";
                                }
				print "</span>\n";
				if( $skipbr ne "all" )
				{
					print "<br>\n";
				}
                                $alsotit++;
                        }
                        print "<span class=\"alsofeatmodel\"><a href=\"".
				Wacs::conf_get_attr("server",$destloc).
                        	$linkto.$afsep.$alsorec[0]."\">".$alsorec[1].
				"</a></span>\n";
			if( $skipbr ne "all" )
			{
				print "<br>\n";
			}
                }
        }
	if( $staysmall eq "Y" && $alsotit > 0 )
        {
                print "</font>\n";
        }
}

#
# read_menu
#
# reads the menu file if present - this is similar to read_conf
# but is not necessarily called by all applications
sub read_menu( $ )
{
	my( $whichmenu )=@_;
	my( $find_menu );

	# major entry point - so refresh the debug level
	$debug=Wacs::conf_get_attr("debug","module_wacsui");
	if( $debug > 3 )
	{
		print STDERR "read_menu: looking for ".$whichmenu.".\n";
	}
	$this_menu = $whichmenu;

	# read the menu file
	$find_menu = Wacs::find_config_location( $whichmenu );
	if( -f $find_menu )
	{
		if( $debug > 3 )
		{
			print STDERR "read_menu: menu file is ".$find_menu.
				".\n";
		}
		# read the menu file into menuhandle
		$menuhandle = XMLin( $find_menu, SuppressEmpty=>1 );
	}
	else
	{
		if( $debug > 0 )
		{
			print STDERR "read_menu: did not find menu: ".
					$whichmenu."\n";
		}
	}
	# menu tree should now be loaded
	if( $debug > 3 )
	{
		print STDERR Dumper( $menuhandle );
	}
}

# 
# menu_get_default
#
# get the default link for a menu
sub menu_get_default( % )
{
	my( %params )=@_;
	my( $mgdname, $mgdcaller, $mgdexclude, $mgdoptions, $mgdresult );

	$mgdname = $params{'name'};
	$mgdcaller = $params{'caller'};
	$mgdexclude = $params{'exclude'};
	$mgdoptions = $params{'options'};
	$mgdoptdesc = $params{'optdesc'};
	$mgdresult='';

	if( exists( $menuhandle->{$mgdname} ))
	{
		# yes, there is a menu of that name
		if( exists( $menuhandle->{$mgdname}->{default} ))
		{
			$mgdresult = menu_dosubs( 
				string=>$menuhandle->{$mgdname}->{default},
				options=>$mgdoptions );
			if( $debug > 3 )
			{
				print STDERR "menu_get_default: ".
						$mgdname." returns ".
						$mgdresult."\n";
			}
		}
		else
		{
			if( $debug > 1 )
			{
				print STDERR "menu_get_default: ".
					$mgdname.": menu has no default.\n";
			}
			# if no default is set, it'll be the front page
			if( $mgdcaller ne "wacsfp" )
			{
				$mgdresult = menu_dosubs( 
					string=>"#WACSMAIN#",
					options=>$mgdoptions );
			}
			else
			{
				# unless it was the front page that called us!
				$mgdresult = menu_dosubs( 
					string=>"#WACSALLM#",
					options=>$mgdoptions );
			}
		}
	}
	else
	{
		if( $debug > 1 )
		{
			print STDERR "menu_get_default: ".
				"no menu called ".$mgdname." is defined.\n";
		}
		# a menu called "navigation" always exists
		if( $mgdname eq "navigation" )
		{
			if( $debug > 1 )
			{
				print STDERR "menu_get_default: ".
					"navigation did not exist; ".
					"defaulted.\n";
			}
			$mgdresult = menu_dosubs( 
				string=>"#WACSMAIN#",
				options=>$mgdoptions );
		}
		elsif( $mgdname eq "search" )
		{
			if( $debug > 1 )
			{
				print STDERR "menu_get_default: ".
					"search did not exist; ".
					"defaulted.\n";
			}
			$mgdresult = menu_dosubs( 
				string=>"#CGIURL#wacslisttags",
				options=>$mgdoptions );
		}
		elsif( $mgdname eq "favourites" )
		{
			if( $debug > 1 )
			{
				print STDERR "menu_get_default: ".
					"favourites did not exist; ".
					"defaulted.\n";
			}
			$mgdresult = menu_dosubs( 
				string=>"#CGIURL#wacsmodelindex/C",
				options=>$mgdoptions );
		}
		elsif( $mgdname eq "newrelated" )
		{
			if( $debug > 1 )
			{
				print STDERR "menu_get_default: ".
					"newrelated did not exist; ".
					"defaulted.\n";
			}
			if( $mgdcaller =~ /wacsnewsets\/$mgdoptions/ )
			{
				$mgdresult = menu_dosubs(
				  string=>"#CGIURL#wacsnewvideo/#OPTIONS#",
				  options=>$mgdoptions ); 
			}
			else
			{
				$mgdresult = menu_dosubs(
				  string=>"#CGIURL#wacsnewsets/#OPTIONS#",
				  options=>$mgdoptions ); 
			}
		}
		elsif( $mgdname eq "alternatives" )
		{
			if( $debug > 1 )
			{
				print STDERR "menu_get_default: ".
					"alternatives did not exist; ".
					"defaulted.\n";
			}
			if( $mgdcaller =~ /wacsmodelindex/ )
			{
				$mgdresult = menu_dosubs(
				  string=>"#CGIURL#wacsmodelthumbs/#OPTIONS#",
				  options=>$mgdoptions,
				  optdesc=>$mgdoptdesc ); 
			}
			else
			{
				$mgdresult = menu_dosubs(
				  string=>"#CGIURL#wacsmodelindex/#OPTIONS#",
				  options=>$mgdoptions,
				  optdesc=>$mgboptdesc ); 
			}
		}
		elsif( $mgdname eq "tagsalt" )
		{
			if( $debug > 1 )
			{
				print STDERR "menu_get_default: ".
					"tagsalt did not exist; ".
					"defaulted.\n";
			}
			if( $mgdcaller =~ /wacstagsets/ )
			{
				$mgdresult = menu_dosubs(
				  string=>
				   "#CGIURL#wacsimglist/tgroup=#OPTIONS#",
				  options=>$mgdoptions,
				  optdesc=>$mgdoptdesc ); 
			}
			else
			{
				$mgdresult = menu_dosubs(
				  string=>"#CGIURL#wacstagsets/#OPTIONS#",
				  options=>$mgdoptions,
				  optdesc=>$mgdoptdesc ); 
			}
		}
		elsif( $mgdname eq "admin" )
		{
			if( $mgdcaller =~ /wacsmodelmgr/ )
			{
				$mgdresult = menu_dosubs(
				   string=>
				    "#CGIURL#wacsdnllist",
				   options=>$mgdoptions,
				   optdesc=>$mgdoptdesc );
			}
			else
			{
				$mgdresult = menu_dosubs(
				   string=>
				    "#CGIURL#wacsmodelmgr",
				   options=>$mgdoptions,
				   optdesc=>$mgdoptdesc );
			}
		}
		# BUILT-IN MENUS IN CORE APPLICATIONS:
		# wacsfp
		elsif( $mgdname eq "fpmenu1" )
		{
			$mgdresult = menu_dosubs(
                                  string=>"#CGIURL#wacsnewsets",
				  options=>$mgdoptions,
                                  optdesc=>$mgdoptdesc );
		}
		elsif( $mgdname eq "fpmenu2" )
		{
			$mgdresult = menu_dosubs(
				  string=>"#CGIURL#wacsimgcats",
				  options=>$mgdoptions,
				  optdesc=>$mgdoptdesc );
		}
		elsif( $mgdname eq "fpmenu3" )
		{
			$mgdresult = menu_dosubs(
				  string=>"#CGIURL#wacsvidcats",
				  options=>$mgdoptions,
				  optdesc=>$mgdoptdesc );
		}
		elsif( $mgdname eq "fpmenu4" )
		{
			$mgdresult = menu_dosubs(
				  string=>"#CGIURL#wacsmodelpage/C",
				  options=>$mgdoptions,
				  optdesc=>$mgdoptdesc );
		}
		elsif( $mgdname eq "fpmenu5" )
		{
			$mgdresult = menu_dosubs( 
				  string=>"#WACSALLM#",
				  options=>$mgdoptions,
				  optdesc=>$mgdoptdesc );
		}
		elsif( $mgdname eq "fpmenu6" )
		{
			$mgdresult = menu_dosubs( 
				  string=>"#CGIURL#wacslistphotog",
				  options=>$mgdoptions,
				  optdesc=>$mgdoptdesc );
		}
		elsif( $mgdname eq "fpmenu7" )
		{
			$mgdresult = menu_dosubs(
				  string=>"#CGIURL#wacslisttags",
				  options=>$mgdoptions,
				  optdesc=>$mgdoptdesc );
		}
		# wacsshow
		elsif( $mgdname eq "showmenu1" )
		{
			$mgdresult = menu_dosubs(
				  string=>"#CGIURL#wacsimgcats",
				  options=>$mgdoptions,
				  optdesc=>$mgdoptdesc );
		}
		elsif( $mgdname eq "showmenu2" )
		{
			$mgdresult = menu_dosubs(
				  string=>"#CGIURL#wacsvidcats",
				  options=>$mgdoptions,
				  optdesc=>$mgdoptdesc );
		}
		elsif( $mgdname eq "altlist" )
		{
			$mgdresult = menu_dosubs(
				  string=>"#OPTIONS#",
				  options=>$mgdoptions,
				  optdesc=>$mgdoptdesc );
		}
		# FIXME: set a global default here?
	}
	# return the result (default is an empty string)
	return( $mgdresult );
}

#
# menu_get_title
#
# get the title of the menu
sub menu_get_title( % )
{
	my( %params )=@_;
	my( $mgtname, $mgtresult );

	$mgtname = $params{'name'};

	# default is the name of the menu with an upper case first letter
	$mgtresult= ucfirst( $mgtname );

	# any specific overrides to this
	if( $mgtname eq "newrelated" )
	{
		$mgtresult = "Related Lists";
	}
	elsif( $mgtname eq "tagsalt" )
	{
		$mgtresult = "Alternatives";
	}
	# these are for wacsfp
	elsif( $mgtname eq "fpmenu1" )
	{
		$mgtresult = "New Additions";
	}
	elsif( $mgtname eq "fpmenu2" )
	{
		$mgtresult = "Image Galleries";
	}
	elsif( $mgtname eq "fpmenu3" )
	{
		$mgtresult = "Video Galleries";
	}
	elsif( $mgtname eq "fpmenu4" )
	{
		$mgtresult = "Models: Selected";
	}
	elsif( $mgtname eq "fpmenu5" )
	{
		$mgtresult = "Models: By Vendor";
	}
	elsif( $mgtname eq "fpmenu6" )
	{
		$mgtresult = "Indices";
	}
	elsif( $mgtname eq "fpmenu7" )
	{
		$mgtresult = "Searches";
	}
	# these are for wacsshow
	elsif( $mgtname eq "showmenu1" )
	{
		$mgtresult = "Other Images";
	}
	elsif( $mgtname eq "showmenu2" )
	{
		$mgtresult = "Other Videos";
	}
	elsif( $mgtname eq "altlist" )
	{
		$mgtresult = "Similar Sets";
	}
	# now the general case of it being in the menu XML file
	if( exists( $menuhandle->{$mgtname} ))
	{
		if( exists( $menuhandle->{$mgtname}->{menutitle} ))
		{
			$mgtresult= $menuhandle->{$mgtname}->{menutitle};
		}
	}

	return( $mgtresult );
}

#
# menu_get_body
#
# get the main menu body for the menu specified
sub menu_get_body( % )
{
	my( %params )=@_;
	my( $mgbname, $mgbcaller, $mgbpre, $mgbintra, $mgbpost, $mgboptions );
	my( $mgboptdesc, $mgbexclude, $mgbisarea, $mgbvsarea, $mgbmflags );
	my( $mgbvsites );
	my( $mgbresult, $mgbtemp, $mgbcount, $mgbentry, %mgbhash );

	# set defaults
	$mgbresult='';
	$mgbtemp='';
	$mgbcount=0;
	$mgbpre="<li><a href=\"";
	$mgbintra="\">";
	$mgbpost="</a></li>";

	# get the parameters past - note that a null string is
	# acceptable as a value if the named parameter exists
	$mgbname=$params{'name'};
	$mgbcaller=$params{'caller'};
	$mgbexclude=$params{'exclude'};
	$mgboptions=$params{'options'};
	$mgboptdesc=$params{'optdesc'};
	$mgbisarea=$params{'isarea'};
	$mgbvsarea=$params{'vsarea'};
	$mgbmflags=$params{'mflags'};
	$mgbvsites=$params{'vsites'};
	if( exists( $params->{'pre'} ))
	{
		$mgbpre=$params{'pre'};
	}
	if( exists( $params->{'intra'} ))
	{
		$mgbpre=$params{'intra'};
	}
	if( exists( $params->{'post'} ))
	{
		$mgbpost=$params{'post'};
	}
	if( $debug > 1 )
	{
		print STDERR "menu_get_body: menu: ".$mgbname." called by ".
				$mgbcaller."\n";
	}

	# now, does the menu they asked for actually have some entries?
	if( exists ($menuhandle->{$mgbname}) )
	{
		if( ! exists $menuhandle->{$mgbname}{entry} )
		{
			if( $debug > 0 )
			{
				print STDERR "menu_get_body: ".
					"no element named entry in menu ".
					$mgbname."\n";
			}
			return null;
		}
		$mgbentry = $menuhandle->{$mgbname}{entry};
		if( $debug > 1 )
		{
			print STDERR "menu_get_body: menu ".$mgbname.
				" exists in ".$this_menu.".\n";
		}
		# first check for a single element menu
		# took me ages to find out how you do a typeof in perl!
		if( $debug > 2 )
		{
			print STDERR "mgbentry is a ".ref( $mgbentry )."\n";
		}
		if( ref($mgbentry) eq "HASH" )
		{
			if( $debug > 1 )
			{
				print STDERR "menu_get_body: ".
					$mgbname." is single element menu.\n";
			}
			$mgbresult .= menu_get_entry(
					name=>$mgbname,
					caller=>$mgbcaller,
					options=>$mgboptions,
					optdesc=>$mgboptdesc,
					pre=>$mgbpre,
					intra=>$mgbintra,
					post=>$mgbpost,
					entry=>$mgbentry,
					isarea=>$mgbisarea,
					vsarea=>$mgbvsarea,
					mflags=>$mgbmflags,
					vsites=>$mgbvsites );
		}
		else
		{
			if( $debug > 1 )
			{
				print STDERR "menu_get_body: ".
					$mgbname." is multi-element menu.\n";
			}
			if( $debug > 3 )
			{
				print "<!---\n";
				print Dumper( $mgbentry )."\n";
				print "--->\n";
			}
			while( exists $mgbentry->[$mgbcount]->{type} )
			{
				$mgbresult .= menu_get_entry(
					name=>$mgbname,
					caller=>$mgbcaller,
					options=>$mgboptions,
					optdesc=>$mgboptdesc,
					pre=>$mgbpre,
					intra=>$mgbintra,
					post=>$mgbpost,
					entry=>$mgbentry->[$mgbcount],
					isarea=>$mgbisarea,
					vsarea=>$mgbvsarea,
					mflags=>$mgbmflags,
					vsites=>$mgbvsites );
				$mgbcount++;
			}
		}
	}
	else
	{
		# menu of that name does not exist
		if( $debug > 0 )
		{
			print STDERR "menu_get_body: menu ".$mgbname.
				" does not exist in ".$this_menu.".\n";
		}
		# OK, create defaulted menus as a catch all
		if( $mgbname eq "navigation" )
		{
			$mgbresult = $mgbpre."#WACSMAIN#".$mgbintra.
				    "Main Menu".$mgbpost."\n";
			if( ! ($mgbcaller =~ /wacsnewmodels/) )
			{
				$mgbresult.= $mgbpre."#CGIURL#wacsnewmodels".
					$mgbintra."Newly Added Models".
					$mgbpost."\n";
			}
			if( ! ($mgbcaller =~ /wacsnewsets/) )
			{
				$mgbresult.= $mgbpre."#CGIURL#wacsnewsets".
					$mgbintra."Newly Added Sets".
					$mgbpost."\n";
			}
			if( ! ($mgbcaller =~ /wacsnewvideo/) )
			{
				$mgbresult.= $mgbpre."#CGIURL#wacsnewvideo".
					$mgbintra."Newly Added Videos".
					$mgbpost."\n";
			}
			$mgbresult.= $mgbpre."#WACSALLM#".$mgbintra.
					"Alphabetic Model Index".$mgbpost."\n";
			if( ! ($mgbcaller =~ /wacslisttags/) )
			{
				$mgbresult.= $mgbpre."#CGIURL#wacslisttags".
					$mgbintra."Saved Searches".
					$mgbpost."\n";
			}
			if( ! ($mgbcaller =~ /wacslistconn/) )
			{
				$mgbresult.= $mgbpre."#CGIURL#wacslistconn".
					$mgbintra."Connections".
					$mgbpost."\n";
			}
			# we'll keep the default version simple - work is
			# need to support photographers and web 2.0 demos
		}
		# default search menu
		elsif( $mgbname eq "search" )
		{
			if( ! ($mgbcaller =~ /wacslisttags/) )
			{
				$mgbresult.= $mgbpre."#CGIURL#wacslisttags".
					$mgbintra."Saved Searches".
					$mgbpost."\n";
			}
			if( ! ($mgbcaller =~ /wacsmodelselect/) )
			{
				$mgbresult.= $mgbpre."#CGIURL#wacsmodelselect".
					$mgbintra."Model Search".
					$mgbpost."\n";
			}
			if( ! ($mgbcaller =~ /wacsimgselect/) )
			{
				$mgbresult.= $mgbpre."#CGIURL#wacsimgselect".
					$mgbintra."Image Set Search".
					$mgbpost."\n";
			}
			if( ! ($mgbcaller =~ /wacsvidselect/) )
			{
				$mgbresult.= $mgbpre."#CGIURL#wacsvidselect".
					$mgbintra."Video Search".
					$mgbpost."\n";
			}
		}
		elsif( $mgbname eq "favourites" )
		{
			if( ! ($mgbcaller =~ /wacsmodelthumbs\/C/) )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacsmodelthumbs/C".
					$mgbintra."Favourite Cuties".
					$mgbpost."\n";
			}
			if( ! ($mgbcaller =~ /wacsmodelthumbs\/S/) )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacsmodelthumbs/S".
					$mgbintra."Favourite Solo".
					$mgbpost."\n";
			}
			if( ! ($mgbcaller =~ /wacsmodelthumbs\/L/) )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacsmodelthumbs/L".
					$mgbintra."Favourite Lesbians".
					$mgbpost."\n";
			}
			if( ! ($mgbcaller =~ /wacsmodelthumbs\/F/) )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacsmodelthumbs/F".
					$mgbintra."Favourite Straight".
					$mgbpost."\n";
			}
			if( ! ($mgbcaller =~ /wacsmodelthumbs\/M/) )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacsmodelthumbs/M".
					$mgbintra."Current Featured Models".
					$mgbpost."\n";
			}
		}
		elsif( $mgbname eq "newrelated" )
		{
			# note the $ on these two so that only the without
			# parameters version will match these.
			if( ! ($mgbexclude =~ /wacsnewsets$/) )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacsnewsets".
					$mgbintra."Images - This #NEWPERIOD#".
					$mgbpost."\n";
			}
			if( ! ($mgbexclude =~ /wacsnewvideo$/) )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacsnewvideo".
					$mgbintra."Videos - This #NEWPERIOD#".
					$mgbpost."\n";
			}
			$mgbresult.= $mgbpre.
				"#CGIURL#wacsnewsets/#OPTIONS#".
				$mgbintra."Images - Previous #NEWPERIOD#".
				$mgbpost."\n";
			$mgbresult.= $mgbpre.
				"#CGIURL#wacsnewvideo/#OPTIONS#".
				$mgbintra."Videos - Previous #NEWPERIOD#".
				$mgbpost."\n";
			$mgbresult.= $mgbpre.
				"#CGIURL#".$mgbexclude."/Tnext".
				$mgbintra."Create An Index".
				$mgbpost."\n";
			if( Wacs::auth_get_attr("ipv4-".$ENV{"REMOTE_ADDR"},
				"prefexcl") ne "" )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#/".$mgbexclude."/N".
					$mgbintra."This Without Exclusions".
					$mgbpost."\n";
			}
		}
		elsif( $mgbname eq "alternatives" )
		{
			if( $mgbcaller =~ /wacsmodelthumbs/ )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacsmodelindex/#OPTIONS#".
					$mgbintra."Model Details: #OPTDESC#".
					$mgbpost."\n";
			}
			else
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacsmodelthumbs/#OPTIONS#".
					$mgbintra."Model Thumbs: #OPTDESC#".
					$mgbpost."\n";
			}
		}
		elsif( $mgbname eq "tagsalt" )
		{
			if( ! ( $mgbcaller =~ /wacsimglist/ ) )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacsimglist/tgroup=#OPTIONS#".
					$mgbintra."Thumbs for Set #OPTIONS#".
					$mgbpost."\n";
			}
			if( ! ( $mgbcaller =~ /wacstagsets/ ) )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacstagsets/#OPTIONS#".
					$mgbintra."Details for Set #OPTIONS#".
					$mgbpost."\n";
			}
			if( ! ( $mgbcaller =~ /wacsslideshow/ ) )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacsslideshow/tag#OPTIONS#".
					$mgbintra."Slide Show: Set #OPTIONS#".
					$mgbpost."\n";
			}
			$mgbresult.= $mgbpre.
					"#CGIURL#wacsmarktag/S#OPTIONS#=reset".
					$mgbintra.
					"Clear Marks in Set #OPTIONS#".
					$mgbpost."\n";
		}
		elsif( $mgbname eq "admin" )
		{
			if( ! ( $mgbcaller =~ /wacsmodelmgr/ ) )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacsmodelmgr/#OPTIONS#".
					$mgbintra."Model Manager".
					$mgbpost."\n";
			}
			if( ! ( $mgbcaller =~ /wacsdnllist/ ) )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacsdnllist".
					$mgbintra."Download List".
					$mgbpost."\n";
			}
			if( ! ( $mgbcaller =~ /wacskeywordmgr/ ) )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacskeywordmgr".
					$mgbintra."Keyword Manager".
					$mgbpost."\n";
			}
			if( ! ( $mgbcaller =~ /wacsaddassoc/ ) )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacsaddassoc".
					$mgbintra."Add Assocation".
					$mgbpost."\n";
			}
			if( ! ( $mgbcaller =~ /wacsphotmgr/ ) )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacsphotmgr".
					$mgbintra."Photographer Manager".
					$mgbpost."\n";
			}
			if( ! ( $mgbcaller =~ /wacsvendmgr/ ) )
			{
				$mgbresult.= $mgbpre.
					"#CGIURL#wacsvendmgr".
					$mgbintra."Vendor Manager".
					$mgbpost."\n";
			}
			$mgbresult.= $mgbpre.
					"#CGIURL#wacsunpackmgr/none".
					$mgbintra."Import Set".
					$mgbpost."\n";
		}
		# Now for the WacsFP Menus - these never need to check
		# against the caller because it should always be wacsfp
		elsif( $mgbname eq "fpmenu1" )
		{
			$mgbresult.= $mgbpre."#CGIURL#wacsnewmodels".
                                        $mgbintra."Newly Added Models".
                                        $mgbpost."\n";
			$mgbresult.= $mgbpre."#CGIURL#wacsnewsets".
                                        $mgbintra."Newly Added Sets".
                                        $mgbpost."\n";
			$mgbresult.= $mgbpre."#CGIURL#wacsnewvideo".
                                        $mgbintra."Newly Added Videos".
                                        $mgbpost."\n";
		}
		elsif( $mgbname eq "fpmenu2" )
		{
			# BEWARE BLACK MAGIC!  Note that in vendormode on
			# wacsfp different isarea and vsarea hashrefs are
			# passed when either fpmenu2 or fpmenu3 are called
			# FOR NOW!!  (may change in future)
			# need to do an assemble of a suitable entry
			# hashref and call parser here
			$mgbhash{"type"}="foreach";
			$mgbhash{"variable"}="isarea";
			$mgbhash{"title"}="#OPTDESC#";
			$mgbhash{"target"}="#CGIURL#wacsshow/sarea=#OPTIONS#";
			$mgbtemp.= menu_get_entry(
				name=>'fpmenu2',
				caller=>$mgbcaller,
				pre=>$mgbpre,
				intra=>$mgbintra,
				post=>$mgbpost,
				entry=>\%mgbhash,
				isarea=>$mgbisarea,
				vsarea=>$mgbvsarea,
				mflags=>$mgbmflags,
				vsites=>$mgbvsites );
			# check valid string, append to results
			if( $mgbtemp ne "" )
			{
				$mgbresult.= $mgbtemp;
			}
			$mgbresult.= $mgbpre."#CGIURL#wacsimgcats".
                                        $mgbintra."Condensed Index".
                                        $mgbpost."\n";
			$mgbresult.= $mgbpre."#CGIURL#wacsimgselect".
                                        $mgbintra."Image Search".
                                        $mgbpost."\n";
		}
		elsif( $mgbname eq "fpmenu3" )
		{
			# BEWARE BLACK MAGIC!  Note that in vendormode on
			# wacsfp different isarea and vsarea hashrefs are
			# passed when either fpmenu2 or fpmenu3 are called
			# FOR NOW!!  (may change in future)
			# need to do an assemble of a suitable entry
			# hashref and call parser here
			$mgbhash{"type"}="foreach";
			$mgbhash{"variable"}="vsarea";
			$mgbhash{"title"}="#OPTDESC#";
			$mgbhash{"target"}=
				"#CGIURL#wacsvidshow/sarea=#OPTIONS#";
			$mgbtemp.= menu_get_entry(
				name=>'fpmenu3',
				caller=>$mgbcaller,
				pre=>$mgbpre,
				intra=>$mgbintra,
				post=>$mgbpost,
				entry=>\%mgbhash,
				isarea=>$mgbisarea,
				vsarea=>$mgbvsarea,
				mflags=>$mgbmflags,
				vsites=>$mgbvsites );
			# check valid string, append to results
			if( $mgbtemp ne "" )
			{
				$mgbresult.= $mgbtemp;
			}
			$mgbresult.= $mgbpre."#CGIURL#wacsvidcats".
                                        $mgbintra."Condensed Index".
                                        $mgbpost."\n";
			$mgbresult.= $mgbpre."#CGIURL#wacsimgselect".
                                        $mgbintra."Video Search".
                                        $mgbpost."\n";
		}
		elsif( $mgbname eq "fpmenu4" )
		{
			$mgbtemp='';
			$mgbhash{"type"}="foreach";
                        $mgbhash{"variable"}="mflags";
			$mgbhash{"title"}="#OPTDESC#s";
			$mgbhash{"target"}="#CGIURL#wacsmodelthumbs/#OPTIONS#";
			$mgbtemp.= menu_get_entry(
                                name=>'fpmenu4',
                                caller=>$mgbcaller,
                                pre=>$mgbpre,
                                intra=>$mgbintra,
                                post=>$mgbpost,
                                entry=>\%mgbhash,
                                isarea=>$mgbisarea,
                                vsarea=>$mgbvsarea,
				mflags=>$mgbmflags,
				vsites=>$mgbvsites );
			# check valid string, append to results
			if( $mgbtemp ne "" )
			{
				$mgbresult.= $mgbtemp;
			}
		}
		elsif( $mgbname eq "fpmenu5" )
		{
			$mgbtemp='';
			$mgbhash{"type"}="foreach";
                        $mgbhash{"variable"}="vsites";
			$mgbhash{"title"}="#OPTDESC# - Best";
			$mgbhash{"target"}=
				"#CGIURL#wacsmodelthumbs/Q=#OPTIONS#";
			$mgbtemp.= menu_get_entry(
                                name=>'fpmenu5',
                                caller=>$mgbcaller,
                                pre=>$mgbpre,
                                intra=>$mgbintra,
                                post=>$mgbpost,
                                entry=>\%mgbhash,
                                isarea=>$mgbisarea,
                                vsarea=>$mgbvsarea,
				mflags=>$mgbmflags,
				vsites=>$mgbvsites );
			# check valid string, append to results
			if( $mgbtemp ne "" )
			{
				$mgbresult.= $mgbtemp;
			}
			# now do all models for these sites
			$mgbtemp='';
			$mgbhash{"title"}="#OPTDESC# - All";
			$mgbhash{"target"}=
				"#CGIURL#wacsmodelthumbs/V=#OPTIONS#";
			$mgbtemp.= menu_get_entry(
                                name=>'fpmenu5',
                                caller=>$mgbcaller,
                                pre=>$mgbpre,
                                intra=>$mgbintra,
                                post=>$mgbpost,
                                entry=>\%mgbhash,
                                isarea=>$mgbisarea,
                                vsarea=>$mgbvsarea,
				mflags=>$mgbmflags,
				vsites=>$mgbvsites );
			# check valid string, append to results
			if( $mgbtemp ne "" )
			{
				$mgbresult.= $mgbtemp;
			}
		}
		elsif( $mgbname eq "fpmenu6" )
		{
			$mgbresult.= $mgbpre."#CGIURL#wacsimgcats".
                                        $mgbintra."Image Sets".
                                        $mgbpost."\n";
			$mgbresult.= $mgbpre."#CGIURL#wacsvidcats".
                                        $mgbintra."Video Clips".
                                        $mgbpost."\n";
			$mgbresult.= $mgbpre."#WACSALLM#".
                                        $mgbintra."Models (Alphabetic)".
                                        $mgbpost."\n";
			$mgbresult.= $mgbpre."#CGIURL#wacslistphotog".
                                        $mgbintra."Photographers".
                                        $mgbpost."\n";
			$mgbresult.= $mgbpre."#CGIURL#wacslistconn".
                                        $mgbintra."Connections".
                                        $mgbpost."\n";
		}
		elsif( $mgbname eq "fpmenu7" )
		{
			$mgbresult.= $mgbpre."#CGIURL#wacsimgselect".
                                        $mgbintra."Image Set Search".
                                        $mgbpost."\n";
			$mgbresult.= $mgbpre."#CGIURL#wacsvidselect".
                                        $mgbintra."Video Clip Search".
                                        $mgbpost."\n";
			$mgbresult.= $mgbpre."#CGIURL#wacsmodelselect".
                                        $mgbintra."Model Search".
                                        $mgbpost."\n";
			$mgbresult.= $mgbpre."#CGIURL#wacslisttags".
                                        $mgbintra."Saved Searches".
                                        $mgbpost."\n";
		}
		# these are for wacsshow
		elsif( $mgbname eq "showmenu1" )
		{
			# need to do an assemble of a suitable entry
			# hashref and call parser here
			$mgbhash{"type"}="foreach";
			$mgbhash{"variable"}="isarea";
			$mgbhash{"title"}="#OPTDESC#";
			$mgbhash{"target"}="#CGIURL#wacsshow/sarea=#OPTIONS#";
			$mgbtemp.= menu_get_entry(
						name=>'showmenu1',
						caller=>$mgbcaller,
						pre=>$mgbpre,
						intra=>$mgbintra,
						post=>$mgbpost,
						entry=>\%mgbhash,
						isarea=>$mgbisarea,
						vsarea=>$mgbvsarea );
			# check valid string, append to results
			if( $mgbtemp ne "" )
			{
				$mgbresult.= $mgbtemp;
			}
		}
		elsif( $mgbname eq "showmenu2" )
		{
			# need to do an assemble of a suitable entry
			# hashref and call parser here
			$mgbhash{"type"}="foreach";
			$mgbhash{"variable"}="vsarea";
			$mgbhash{"title"}="#OPTDESC#";
			$mgbhash{"target"}="#CGIURL#wacsvidshow/sarea=#OPTIONS#";
			$mgbtemp.= menu_get_entry(
						name=>'showmenu2',
						caller=>$mgbcaller,
						pre=>$mgbpre,
						intra=>$mgbintra,
						post=>$mgbpost,
						entry=>\%mgbhash,
						isarea=>$mgbisarea,
						vsarea=>$mgbvsarea );
			# check valid string, append to results
			if( $mgbtemp ne "" )
			{
				$mgbresult.= $mgbtemp;
			}
		}
		# this is fairly generic and uses the options and
		# optdesc values
		elsif( $mgbname eq "altlist" )
		{
			# need to do an assemble of a suitable entry
			# hashref and calleh parser here
			$mgbhash{"type"}="foreach";
			$mgbhash{"variable"}="options";
			$mgbhash{"title"}="#OPTDESC#";
			$mgbhash{"target"}="#OPTIONS#";	
			$mgbtemp.= menu_get_entry(
					name=>'altlist',
					caller=>$mgbcaller,
					pre=>$mgbpre,
					intra=>$mgbintra,
					post=>$mgbpost,
					entry=>\%mgbhash,
					options=>$mgboptions,
					optdesc=>$mgboptdesc );
			# check valid string, append to results
			if( $mgbtemp ne "" )
			{
				$mgbresult.= $mgbtemp;
			}
		}
	}
	# return what we've assembled with the config file constants
	# substituted.
	return( menu_dosubs( string=>$mgbresult,
			options=>$mgboptions,
			optdesc=>$mgboptdesc ) );
}

#
# menu_get_entry
#
# get a specific menu entry
sub menu_get_entry( % )
{
	my( %params )=@_;
	my( $mgename, $mgecaller, $mgepre, $mgeintra, $mgepost, $mgeentry );
	my( $mgeoptions, $mgeoptdesc, $mgeisarea, $mgevsarea, $mgemflags );
	my( $mgevsites );
	my( $mgeresult, $mgenext );

	# copy accross the parameters
	$mgename = $params{'name'};
	$mgecaller = $params{'caller'};
	$mgeoptions = $params{'options'};
	$mgeoptdesc = $params{'optdesc'};
	$mgepre = $params{'pre'};
	$mgeintra = $params{'intra'};
	$mgepost = $params{'post'};
	$mgeentry = $params{'entry'};
	$mgeisarea = $params{'isarea'};
	$mgevsarea = $params{'vsarea'};
	$mgemflags = $params{'mflags'};
	$mgevsites = $params{'vsites'};

	# debugging
	if( $debug > 3 )
	{
		print "<!---\n";
		print Dumper( $mgeentry )."\n";
		print "--->\n";
	}

	# sanity check
	if( ! exists( $mgeentry->{type} ))
	{
		print STDERR "menu_get_entry: corrupt entry passed.\n";
		return '';
	}

	# work out what to do
	if( $mgeentry->{type} eq "static" )
	{
		if( $mgeentry->{target} =~ /$mgecaller/ )
		{
			if( $debug > 1 )
			{
				print STDERR "menu_get_entry: static: target ".
					$mgeentry->{target}." matches caller ".
					$mgecaller." in ".$mgename.".\n";
			}
			return '';
		}
		if( $debug > 3 )
		{
			print STDERR "menu_get_entry: static: result: ".
				$mgepre.$mgeentry->{target}.$mgeintra.
				$mgeentry->{title}.$mgepost."\n";
		}
		return( $mgepre.$mgeentry->{target}.$mgeintra.
			$mgeentry->{title}.$mgepost."\n" );
	}
	elsif( $mgeentry->{type} eq "divider" )
	{
		return( $mgepre.''.$mgeintra.'<hr>'.$mgepost."\n");
	}
	elsif( $mgeentry->{type} eq "heading" )
	{
		if( exists $mgeentry->{target} )
		{
			return( $mgepre.$mgeentry->{target}.$mgeintra.
				$mgeentry->{title}.$mgepost."\n" );
		}
		else
		{
			return( $mgepre.''.$mgeintra."<font size=-1><b>".
				$mgeentry->{title}.
				"</b></font>".$mgepost."\n" );
		}
	}
	elsif( $mgeentry->{type} eq "foreach" )
	{
		$mgeresult='';
		if( $mgeentry->{variable} eq "isarea" )
		{
			if( $debug > 3 )
			{
				print STDERR "mgeisarea: ".
						Dumper( $mgeisarea )."\n";
			}
			foreach $mgenext ( sort keys %{$mgeisarea} )
			{
				$mgeresult .= menu_dosubs( 'string'=>
					  $mgepre.$mgeentry->{target}.
					  $mgeintra.$mgeentry->{title}.
					  $mgepost,
					  'options'=>$mgenext,
					  'optdesc'=>$mgeisarea->{$mgenext} );
			}
		}
		elsif( $mgeentry->{variable} eq "vsarea" )
		{
			if( $debug > 3 )
			{
				print STDERR "mgevsarea: ".
						Dumper( $mgevsarea )."\n";
			}
			foreach $mgenext ( sort keys %{$mgevsarea} )
			{
				$mgeresult .= menu_dosubs( 'string'=>
                                          $mgepre.$mgeentry->{target}.
                                          $mgeintra.$mgeentry->{title}.
                                          $mgepost,
                                          'options'=>$mgenext,
                                          'optdesc'=>$mgevsarea->{$mgenext} );
			}
		}
		elsif( $mgeentry->{variable} eq "mflags" )
		{
			if( $debug > 3 )
			{
				print STDERR "mgemflags: ".
						Dumper( $mgemflags )."\n";
			}
			foreach $mgenext ( sort keys %{$mgemflags} )
			{
				$mgeresult .= menu_dosubs( 'string'=>
                                          $mgepre.$mgeentry->{target}.
                                          $mgeintra.$mgeentry->{title}.
                                          $mgepost,
                                          'options'=>$mgenext,
                                          'optdesc'=>$mgemflags->{$mgenext} );
			}
		}
		elsif( $mgeentry->{variable} eq "vsites" )
		{
			if( $debug > 3 )
			{
				print STDERR "mgevsites: ".
						Dumper( $mgevsites )."\n";
			}
			foreach $mgenext ( sort keys %{$mgevsites} )
			{
				$mgeresult .= menu_dosubs( 'string'=>
                                          $mgepre.$mgeentry->{target}.
                                          $mgeintra.$mgeentry->{title}.
                                          $mgepost,
                                          'options'=>$mgenext,
                                          'optdesc'=>$mgevsites->{$mgenext} );
			}
		}
		elsif( $mgeentry->{variable} eq "options" )
		{
			if( $debug > 3 )
			{
				print STDERR "options: ".
						Dumper( $mgeoptions )."\n";
			}
			foreach $mgenext ( sort keys %{$mgeoptions} )
			{
				print STDERR "working on ".$mgenext."\n";
				print STDERR $mgenext." is ".
					$mgeoptions->{$mgenext}."\n";
				$mgeresult .= menu_dosubs( 'string'=>
                                          $mgepre.$mgeentry->{target}.
                                          $mgeintra.$mgeentry->{title}.
                                          $mgepost,
                                          'options'=>$mgeoptions->{$mgenext},
                                          'optdesc'=>$mgeoptdesc->{$mgenext} );
			}
		}
		if( $debug > 3 )
		{
			print STDERR "menu_get_entry: foreach: result: ".
				$mgeresult .".\n";
		}
		return( $mgeresult );
	}
	else
	{
		print STDERR "menu_get_entry: unknown type ".
			$mgeentry->{type}." in menu ".$mgename.".\n";
	}
	return null;
}

#
# menu_get_handler
#
# provide the URL that handles various types of data in this menu's world
sub menu_get_handler( % )
{
	my( %params )=@_;
	my( $mghfor, $mghoptions, $mghstring );
	$mghfor = $params{'for'};
	$mghoptions = $params{'options'};
	$mghstring='';

	# set some default values
	if( $mghfor eq "models" )
	{
		$mghstring = "#CGIURL#wacsmpthumbs/#OPTIONS#";
	}
	elsif( $mghfor eq "photographer" )
	{
		$mghstring = "#CGIURL#wacsphotcats/#OPTIONS#";
	}
	else
	{
		$mghstring ='';
	}
	# override the defaults if specified
	if( exists( $menuhandle->{handlers} ) )
	{
		# handler specification does exist
		if( exists( $menuhandle->{handlers}->{$mghfor} ))
		{
			$mghstring = $menuhandle->{handlers}->{$mghfor};
		}
	}
	
	return( menu_dosubs( string=>$mghstring,
			     options=>$mghoptions ));
}

#
# menu_dosubs
#
# do necessary substitutions for a menu entry
sub menu_dosubs( % )
{
	my( %params )=@_;
	my( $mdsstring, $mdsoptions, $mdsoptdesc );
	my( $mdsvalue, $newperiod, $newpname );
	$mdsstring = $params{'string'};
	$mdsoptions = $params{'options'};
	$mdsoptdesc = $params{'optdesc'};

	# these are individual rather than cascaded tests so that multiple
	# substitutions do in fact work if needed
	if( $mdsstring =~ /#OPTIONS#/ )
	{
		# mdsoptions could be null, but we don't want the hashed
		# tag left there.
		$mdsstring =~ s/#OPTIONS#/$mdsoptions/g;
	}
	if( $mdsstring =~ /#OPTDESC#/ )
	{
		# mdsoptdesc could be null, but we don't want the hashed
		# tag left there.
		$mdsstring =~ s/#OPTDESC#/$mdsoptdesc/g;
	}
	if( $mdsstring =~ /#BASEURL#/ )
	{
		$mdsvalue = Wacs::conf_get_attr("server","baseurl");
		$mdsstring =~ s/#BASEURL#/$mdsvalue/g;
	}
	if( $mdsstring =~ /#CGIURL#/ )
	{
		$mdsvalue = Wacs::conf_get_attr("server","cgiurl");
		$mdsstring =~ s/#CGIURL#/$mdsvalue/g;
	}
	if( $mdsstring =~ /#ICONURL#/ )
	{
		$mdsvalue = Wacs::conf_get_attr("server","iconurl");
		$mdsstring =~ s/#ICONURL#/$mdsvalue/g;
	}
	if( $mdsstring =~ /#SITEURL#/ )
	{
		$mdsvalue = Wacs::conf_get_attr("server","siteurl");
		$mdsstring =~ s/#SITEURL#/$mdsvalue/g;
	}
	if( $mdsstring =~ /#WACSURL#/ )
	{
		$mdsvalue = Wacs::conf_get_attr("server","wacsurl");
		$mdsstring =~ s/#WACSURL#/$mdsvalue/g;
	}
	if( $mdsstring =~ /#WACSMAIN#/ )
	{
		$mdsvalue = Wacs::conf_get_attr("server","wacsmain");
		$mdsstring =~ s/#WACSMAIN#/$mdsvalue/g;
	}
	if( $mdsstring =~ /#WACSALLM#/ )
	{
		$mdsvalue = Wacs::conf_get_attr("server","wacsallm");
		$mdsstring =~ s/#WACSALLM#/$mdsvalue/g;
	}
	if( $mdsstring =~ /#NEWPERIOD#/ )
	{
		# only work this out if we're actually using it!
		$newperiod = Wacs::conf_get_attr("layout","newperiod");
		if( $newperiod == 6 || $newperiod == 7 || $newperiod == 8 )
		{
			$newpname = "Week";
		}
		elsif( $newperiod == 14 || $newperiod == 15 )
		{
			$newpname = "Fortnight";
		}
		elsif( $newperiod == 28 || $newperiod == 29 ||
			$newperiod == 30 || $newperiod == 31 )
		{
			$newpname = "Month";
		}
		elsif( $newperiod == 90 || $newperiod == 91 ||
			$newperiod == 92 || $newperiod == 93 )
		{
			$newpname = "Quarter";
		}
		else
		{
			$newpname = $newperiod." days";
		}
		$mdsstring =~ s/#NEWPERIOD#/$newpname/g;
	}
	return( $mdsstring );
}

# show that we have parsed correctly
1;
__END__

=head1 NAME

Wacs - Web Adult Content Server - User Interface Components Module

=head1 NOTICE

THIS PROJECT DOES NOT CONTAIN ANY ADULT MATERIAL.  Rather it is a 
toolkit for presenting and managing your own collections by enabling
you to access those collections in a way similar to that provided by
subscription web sites.  Hopefully it contains many of the necessary
tools to create a good-looking site with best-of-breed facilities.

The idea of the project is to make a system for personal use, but Wacs
is quite capable of hosting an internet accessible site.  Before doing
so however, the author strongly recommends you consider the legal and
copyright infringement issues that could arise out of such an action. 
Those of you in the USA definitely need to consider the implications of
18 USC 2257 carefully.

=head1 SYNOPSIS

describeher() - tries to make a sensible sentance out of model data
whatshedoes() - describes the kind of sets this model appears in
addkeyicons() - makes a little HTML table with the attribute icons
addratings() - makes a little HTML table with rating icons
findmodel() - search for models by name
iconlink() - build a link around the icon for this set
addlinks() - add standard navigation links
read_menu() - locate and read the XML based menu configuration file
menu_get_default() - get what the default link for a menu should be
menu_get_title() - get what the menu title should be
menu_get_body() - get the body of the menu
menu_get_handler() - get the command name to handle this type of value
